C  8/2/96   SUBROUTINE Q3TH
C  ----- 1/11/94
C
      SUBROUTINE HMCHYD(ITM,KPR,EPS,
     I    COORD,IE,LRN,NLRN,LRL,NLRL,ND, PROP,RHOMU,RHOM,
     I    DINTS,SPP,CP, HP, SOSH,ISTYPH, WSSH,IWTYPH, QCB,ICTYPH,ISCH,
     I    QNB,INTYPH,ISNH,DLCSNH, RFALL,IRTYP,ISR,DLCSR,RSVAB,INDRS,
     I    HDB,IDTYPH, IRHO, SOS,ISTYP,WSS,IWTYP,
     O    H,HT,TH,DTH,AKHC,VELOC,
     M    HW,CMATRX,RLD,RL,RI)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO SOLVE RICHARDS' EQUATION WITH SOURCE/SINK TERMS FOR
C ------- THE STEADY STATE CASE OR FOR ONE TIME STEP SUBJECT TO
C ------- APPROPRIATE BOUNDARY CONDITIONS.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
C
      COMMON /TIMER/ DELT,CHNG,DELMAX,TMAX,DELT0,TIME
C
      COMMON /COUTP/ IITR,ICHNG,INTER,IBUG
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
      COMMON /HRCNT/ TOLAH,TOLBH,WF,OMEH,OMIH,CNSTKR
C
      COMMON /HELS/ MXSELH,MXSPRH,MXSDPH,NSELH,NSPRH,NSDPH,KSAIH
      COMMON /HNPS/ MXWNPH,MXWPRH,MXWDPH,NWNPH,NWPRH,NWDPH,KWAIH
      COMMON /TELS/ MXSEL,MXSPR,MXSDP,NSEL,NSPR,NSDP,KSAI
      COMMON /TNPS/ MXWNP,MXWPR,MXWDP,NWNP,NWPR,NWDP,KWAI
C
      COMMON /HCBC/ MXCNPH,MXCESH,MXCPRH,MXCDPH,NCNPH,NCESH,NCPRH,
     >              NCDPH,KCAIH
      COMMON /HNBC/ MXNNPH,MXNESH,MXNPRH,MXNDPH,NNNPH,NNESH,NNPRH,
     >              NNDPH,KNAIH
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
      COMMON /HDBC/ MXDNPH,MXDPRH,MXDDPH,NDNPH,NDPRH,NDDPH,KDAIH
      COMMON /CHEM/ MXNCC,NCC
C
      DIMENSION COORD(MAXNP,2),IE(MAXEL,9),LRN(MXJBD,MXADNP)
      DIMENSION NLRN(MAXNP),LRL(MXKBD,MAXNP),NLRL(MAXNP),ND(MXADNP)
      DIMENSION PROP(MAXMAT,MXMPPM),SPP(MXSPPM,MAXMAT,4)
      DIMENSION CP(MAXNP,MXNCC),RHOMU(MXNCC),DINTS(MXNCC),RHOM(4,MAXEL)
C
      DIMENSION SOSH(MXSPRH),ISTYPH(MXSELH,2)
      DIMENSION WSSH(MXWPRH),IWTYPH(MXWNPH,2)
      DIMENSION ISTYP(MXSEL,MXNCC),SOS(MXSPR,2)
      DIMENSION IWTYP(MXWNP,MXNCC),WSS(MXWPR,2)
C
      DIMENSION QCB(MXCPRH),ICTYPH(MXCNPH,2), ISCH(5,MXCESH)
      DIMENSION QNB(MXNPRH),INTYPH(MXNNPH,2),DLCSNH(3,MXNESH),
     >          ISNH(5,MXNESH)
      DIMENSION RFALL(MXRPR),IRTYP(MXRNP,2),DLCSR(3,MXRES),ISR(5,MXRES),
     >          RSVAB(MXRNP,4),INDRS(MXRNP,3)
      DIMENSION HDB(MXDPRH),IDTYPH(MXDNPH,2)
C
      DIMENSION H(MAXNP),HP(MAXNP),HT(MAXNP),TH(MAXEL,4),
     1          DTH(MAXEL,4),AKHC(4,MAXEL,3),VELOC(MAXNP,2)
C
      DIMENSION CMATRX(MXADNP,MAXBW),RLD(MXADNP),RL(MXADNP),RI(MXADNP)
      DIMENSION HW(MAXNP)
C
      DATA KDIG/0/
C
      IF(KSSH.NE.0) GO TO 500
C
C $$$$$$$ PERFORM STEADY-STATE CALCULATION
C
      IF(NRNP.EQ.0) GO TO 170
      DO 150 NPP=1,NRNP
      INDRS(NPP,1)=IRTYP(NPP,2)
      INDRS(NPP,2)=0
  150 INDRS(NPP,3)=0
C
      NCHG=-1
C
      CALL BCPREP
     I    (H,VELOC,RFALL,IRTYP,DLCSR,ISR,
     O     NCHG,
     M     RSVAB,INDRS)
C
  170 DO 180 NP=1,NNP
  180 HP(NP)=H(NP)
C
      KDIG=KDIG+1
      IF(IITR.NE.0) WRITE(16,1000) KDIG,TIME,DELT
C
C ------- ITERATION LOOP ON SEEPAGE-RAINFALL BOUNDARY CONDITIONS BEGINS
C
      NNCVN=0
      DO 390 ICY=1,NCYL
C
      DO 210 NP=1,NNP
        IF(NNCVN.NE.0)THEN
          HW(NP)=HP(NP)
        ELSE
          HW(NP)=OMEH*H(NP)+(1.0D0-OMEH)*HP(NP)
        ENDIF
          IF(IPNTS.EQ.1) RI(NP)=HW(NP)
  210 CONTINUE
C
C ------- ITERATION LOOP ON THE NON-LINEAR EQUATION BEGINS
C
      IF(IITR.NE.0) WRITE(16,3000) ICY
C
C ------- PUT DIRICHELT BOUNDARY VALUES OF THE VARIABLE BOUNDARY
C------- INTO H, RI, AND HW
      IF(NRES.EQ.0) GO TO 240
      DO 230 NPP=1,NRNP
      NI=INDRS(NPP,2)
      IF(NI.EQ.0) GO TO 220
      H(NI)=RSVAB(NPP,2)
      RI(NI)=RSVAB(NPP,2)
      HW(NI)=RSVAB(NPP,2)
      GO TO 230
 220  NI=INDRS(NPP,1)
      IF(NI.EQ.0) GO TO 230
      H(NI)=RSVAB(NPP,1)
      RI(NI)=RSVAB(NPP,1)
      HW(NI)=RSVAB(NPP,1)
 230  CONTINUE
 240  CONTINUE
      DO 350 IT=1,NITERH
C
C ------- EVALUATE SOIL PROPERTIES FOR PREVIOUS ITERATE
C
      CALL SPROP
     I         (IE,HW, CP, PROP,RHOMU,DINTS,SPP,IRHO,IQUAR,
     O          TH,DTH,AKHC,RHOM)
C
C ------- ASSEMBLE STEADY-STATE ELEMENT MATRICES QA AND QB INTO THE
C ------- GLOBAL MATRIX CMATRX AND CONSTRUCT GLOBAL LOAD VECTOR RLD
C ------- FROM ELEMENT LOAD VECTOR RQ.
C
      CALL FASEMB
     I  (COORD,IE,LRN,NLRN, HP,TH,DTH,AKHC,RHOM,SOSH,ISTYPH,WSSH,
     I   IWTYPH, CP,LRL,NLRL,PROP,DINTS,RHOMU,IRHO, SOS,ISTYP,WSS,IWTYP,
     O   CMATRX,RLD)
C
C ------- APPLY STEADY-STATE BOUNDARY CONDITIONS
C
      CALL FBC
c     I    (COORD,IE,LRN,NLRN, AKHC, QCB,ICTYPH,ISCH, QNB,INTYPH,ISNH,
     I    (COORD,LRN,NLRN, AKHC, QCB,ICTYPH,ISCH, QNB,INTYPH,ISNH,
     I     DLCSNH, RSVAB,INDRS,RFALL,IRTYP,DLCSR,ISR, HDB,IDTYPH, RHOM,
     M     CMATRX,RLD)
C
      IF(IPNTS.EQ.1) GO TO 250
C
      CALL BANSOL(1,CMATRX,RLD,NNP,IHBP,MXADNP,MAXBW,MXADNP)
      CALL BANSOL(2,CMATRX,RLD,NNP,IHBP,MXADNP,MAXBW,MXADNP)
C
      GO TO 300
C
  250 CONTINUE
      DO NP=1,NNP
        RL(NP)=RLD(NP)
      ENDDO
      CALL PISS
     I    (MAXNP,MXJBD,MAXBW,MXADNP,  NNP,NPITERH,  OMIH,EPS,
     I     KPR,IBUG, CMATRX,RI,RL,LRN,NLRN,ND, 1,
     O     RLD)
C
C ------- OBTAIN MAXIMUM RELATIVE DEVIATION FROM PREVIOUS ITERATE
C
  300 CONTINUE
C
      NPP=0
      RD=-1.0D0
      RES=-1.0D0
      DO 320 NP=1,NNP
      RESNP=DABS(RLD(NP)-H(NP))
      RES=DMAX1(RES,RESNP)
      IF(H(NP).NE.0.0D0) RD=DMAX1(RD,DABS(RESNP/H(NP)))
      IF(RESNP .LE. TOLAH) GO TO 320
      NPP=NPP+1
  320 CONTINUE
C
      NNCVN=NPP
C
C ------- UPDATE PRESSURE WITH CURRENT ITERATE
C
      DO 330 NP=1,NNP
      H(NP)=OMEH*RLD(NP)+(1.0D0-OMEH)*H(NP)
      IF(IPNTS.EQ.1) RI(NP)=H(NP)
      HW(NP)=H(NP)
  330 CONTINUE
C
C ------- ESCAPE FROM ITERATION LOOP IF THE MAXIMUM RESIDUAL IS
C ------- SUFFICIENTLY SMALL
C
      IF(IBUG.NE.0) WRITE(16,3300) IT,RES,RD,NNCVN
      IF(IT.EQ.1) GO TO 350
      IF(RES.LT.TOLAH) GO TO 360
      IF(RES.GT.1.0D38)GOTO 355
C
  350 CONTINUE
  355 CONTINUE
C
C ------- END OF ITERATION LOOP ON THE NON-LINEAR EQUATION
C
      WRITE(16,3500) ICY,IT,NITERH,RES,RD,NNCVN
C
  360 IF(NRNP.EQ.0) GO TO 380
      IF(ICHNG.EQ.0) GO TO 380
C
C ------- PRINT RAINFALL-SEEPAGE B. C. CHANGE INFORMATION
C
      WRITE(16,3700) ICY
      DO 370 I=1,NRNP
      NP=IRTYP(I,2)
      WRITE(16,3710) I,NP,INDRS(I,1),RSVAB(I,1),INDRS(I,2),RSVAB(I,2),
     1 INDRS(I,3),RSVAB(I,3),RSVAB(I,4)
  370 CONTINUE
C
C ------- CALCULATE DARCY'S VELOCITY
C
  380 CONTINUE
      CALL SPROP
     I         (IE,H,CP, PROP,RHOMU,DINTS,SPP, IRHO,IQUAR,
     O          TH,DTH,AKHC,RHOM)
C
      CALL VELT
     I         (COORD,IE,H,AKHC,RHOM,
     O          VELOC,HT,
     M          CMATRX)
C
      IF(NRNP .EQ. 0) GO TO 440
C
C ------- PREPARE BOUNDARY CONDITIONS ON THE VARIABLE-TYPE BOUNDARY FOR
C ------- NEXT CYCLE COMPUTATIONS.
C
      CALL BCPREP
     I    (H,VELOC,RFALL,IRTYP,DLCSR,ISR,
     O     NCHG,
     M     RSVAB,INDRS)
C
      IF(NCHG.EQ.0) GO TO 440
C
  390 CONTINUE
C
C ------- END OF ITERATION LOOP ON SEEPAGE-RAINFALL BOUNDARY CONDITIONS
C
      WRITE(16,3900) ICY,IT,NCYL,NITERH,RES,RD,NNCVN
  440 IF(IITR.NE.0 .AND. NNCVN.EQ.0) WRITE(16,3910) ICY,IT
      IF(NNCVN.EQ.0) GO TO 445
      WRITE(16,3900) ICY,IT,NCYL,NITERH,RES,RD,NNCVN
C
  445  RETURN
C
C $$$$$$$ PERFORM TRANSIENT-STATE OR TRANSIENT CALCULATION
C
  500 CONTINUE
      IF(NRNP.EQ.0 .OR. ITM.GT.1) GO TO 550
      DO 510 NPP=1,NRNP
      INDRS(NPP,1)=IRTYP(NPP,2)
      INDRS(NPP,2)=0
  510 INDRS(NPP,3)=0
C
  550 NCHG=-1
C
      CALL BCPREP
     I    (H,VELOC,RFALL,IRTYP,DLCSR,ISR,
     O     NCHG,
     M     RSVAB,INDRS)
C
      W1=WF
      W2=1.0D0-WF
C
      KDIG=KDIG+1
      IF(IITR.NE.0 .AND. KPR.NE.0) WRITE(16,1000) KDIG,TIME,DELT
C
C ------- BEGIN ITERATION LOOP ON SEEPAGE-RAINFALL BOUNDARY CONDITIONS
C
      NNCVN=0
      DO 690 ICY=1,NCYL
      IF(IITR.NE.0 .AND. KPR.NE.0) WRITE(16,3000) ICY
C
      DO 580 NP=1,NNP
        IF(NNCVN.NE.0)THEN
          H(NP)=HP(NP)
          HW(NP)=HP(NP)
        ELSE
          H(NP)=OMEH*RLD(NP)+(1.0D0-OMEH)*H(NP)
          HW(NP)=W1*(OMEH*H(NP)+(1.0D0-OMEH)*HP(NP))+W2*HP(NP)
        ENDIF
        IF(IPNTS.EQ.1) RI(NP)=H(NP)
  580 CONTINUE
C
C ------- BEGIN ITERATION LOOP ON THE NON-LINEAR EQUATION
C
C ------- PUT DIRICHLET BOUNDARY VALUES OF THE VARIABLE BOUNDARY
C------- INTO H, RI, AND HW
      IF(NRES.EQ.0) GO TO 595
      DO 590 NPP=1,NRNP
      NI=INDRS(NPP,2)
      IF(NI.EQ.0) GO TO 585
      H(NI)=RSVAB(NPP,2)
      RI(NI)=RSVAB(NPP,2)
      HW(NI)=RSVAB(NPP,2)
      GO TO 590
 585  NI=INDRS(NPP,1)
      IF(NI.EQ.0) GO TO 590
      H(NI)=RSVAB(NPP,1)
      RI(NI)=RSVAB(NPP,1)
      HW(NI)=RSVAB(NPP,1)
 590  CONTINUE
 595  CONTINUE
      DO 650 IT=1,NITERH
C
C ------- EVALUATE SOIL PROPERTIES FOR PREVIOUS ITERATE
C
      CALL SPROP
     I         (IE,HW,CP, PROP,RHOMU,DINTS,SPP, IRHO,IQUAR,
     O          TH,DTH,AKHC,RHOM)
C
C ------- ASSEMBLE TRANSIENTSTATE OR TRANSIENT ELEMENT MATRICES QA AND
C ------- QB INTO THE GLOBAL MATRIX CMATRX AND CONSTRUCT GLOBAL LOAD
C ------- VECTOR RLD FROM ELEMENT LOAD VECTOR RQ.
C
      CALL FASEMB
     I  (COORD,IE,LRN,NLRN, HP,TH,DTH,AKHC,RHOM,SOSH,ISTYPH,WSSH,
     I   IWTYPH, CP,LRL,NLRL,PROP,DINTS,RHOMU, IRHO,SOS,ISTYP,WSS,IWTYP,
     O   CMATRX,RLD)
C
C ------- APPLY TRANSIENT STATE OR TRANSIENT BOUNDARY CONDITIONS
C
      CALL FBC
c     I    (COORD,IE,LRN,NLRN, AKHC,  QCB,ICTYPH,ISCH, QNB,INTYPH,ISNH,
     I    (COORD,LRN,NLRN, AKHC,  QCB,ICTYPH,ISCH, QNB,INTYPH,ISNH,
     I     DLCSNH, RSVAB,INDRS,RFALL,IRTYP,DLCSR,ISR, HDB,IDTYPH, RHOM,
     M     CMATRX,RLD)
C
      IF(IPNTS.EQ.1) GO TO 596
C
      CALL BANSOL(1,CMATRX,RLD,NNP,IHBP,MXADNP,MAXBW,MXADNP)
      CALL BANSOL(2,CMATRX,RLD,NNP,IHBP,MXADNP,MAXBW,MXADNP)
      GO TO 600
C
  596 CONTINUE
      DO NP=1,NNP
        RL(NP)=RLD(NP)
      ENDDO
      CALL PISS
     I    (MAXNP,MXJBD,MAXBW,MXADNP,  NNP,NPITERH,  OMIH,EPS,
     I     KPR,IBUG, CMATRX,RI,RL,LRN,NLRN,ND, 1,
     O     RLD)
C
C ------- OBTAIN MAXIMUM RELATIVE DEVIATION FROM PREVIOUS ITERATE
C
  600 CONTINUE
      NPP=0
      RD=-1.0D0
      RES=-1.0D0
C     WRITE(16,203)(RLD(IR),IR=1,NNP)
C 203 FORMAT(10E12.4)
      DO 620 NP=1,NNP
      RESNP=DABS(RLD(NP)-H(NP))
      RES=DMAX1(RES,RESNP)
      IF(H(NP) .NE. 0.0D0) RD=DMAX1(RD,DABS(RESNP/H(NP)))
      IF(RESNP .LE. TOLBH) GO TO 620
      NPP=NPP+1
  620 CONTINUE
C
      NNCVN=NPP
C
C ------- UPDATE PRESSURE WITH CURRENT ITERATE
C
      DO 630 NP=1,NNP
      H(NP)=OMEH*RLD(NP)+(1.0D0-OMEH)*H(NP)
      IF(IPNTS.EQ.1) RI(NP)=H(NP)
      HW(NP)=W1*H(NP)+W2*HP(NP)
  630 CONTINUE
C
C ------- ESCAPE FROM ITERATION LOOP IF THE MAXIMUM RESIDUAL IS
C ------- SUFFICIENTLY SMALL.
C
      IF(IITR.NE.0 .AND. KPR.NE.0) WRITE(16,3300) IT,RES,RD,NNCVN
      IF(IT.EQ.1 .AND. ITM.EQ.1) GO TO 650
      IF(RES.LT.TOLBH) GO TO 660
      IF(RES.GT.1.0D38) GOTO 655
C
  650 CONTINUE
  655 CONTINUE
C
C ------- END THE ITERATION LOOP ON THE NON-LINEAR EQUATION
C
      WRITE(16,6500) ITM,ICY,IT,NITERH,RES,RD,NNCVN
C
  660 IF(NRNP.EQ.0) GO TO 680
      IF(ICHNG.EQ.0 .OR. KPR.EQ.0) GO TO 680
C
C ------- PRINT RAINFALL-SEEPAGE BOUNDARY CONDITION CHANGE INFORMATION
C
      WRITE(16,3700) ICY
      DO 670 I=1,NRNP
      NP=IRTYP(I,2)
      WRITE(16,3710) I,NP,INDRS(I,1),RSVAB(I,1),INDRS(I,2),RSVAB(I,2),
     1 INDRS(I,3),RSVAB(I,3),RSVAB(I,4)
  670 CONTINUE
C
C ------- CALCULATE DARCY'S VELOCITY
C
  680 CONTINUE
      CALL SPROP
     I          (IE,H,CP, PROP,RHOMU,DINTS,SPP, IRHO,IQUAR,
     O           TH,DTH,AKHC,RHOM)
C
      CALL VELT
     I         (COORD,IE,H,AKHC,RHOM,
     O          VELOC,HT,
     M          CMATRX)
C
      IF(NRNP.EQ.0) GO TO 710
C
      CALL BCPREP
     I    (H,VELOC,RFALL,IRTYP,DLCSR,ISR,
     O     NCHG,
     M     RSVAB,INDRS)
C
      IF(NCHG.EQ.0) GO TO 710
C
  690 CONTINUE
C
C ------- END ITERATION LOOP ON SEEPAGE-RAINFALL BOUNDARY CONDITIONS
C
      WRITE(16,6900) ITM,ICY,IT,NCYL,NITERH,RES,RD,NNCVN
  710 IF(IITR.NE.0 .AND. NNCVN.EQ.0) WRITE(16,6910) ITM,ICY,IT
      IF(NNCVN.EQ.0) GO TO 715
      WRITE(16,6900) ITM,ICY,IT,NCYL,NITERH,RES,RD,NNCVN
C
  715 CONTINUE
C
      RETURN
C
 1000 FORMAT(' ',72('*')
     2 ///' DIAGNOSTIC TABLE',I4,'.. AT TIME =',1PD12.4,
     3 ' ,(DELT =',1PD12.4,')')
 3000 FORMAT(//'TABLE OF ITERATIVE PARAMETERS FOR',I3,'-TH CYCLE'//6X,
     1 'ITERATION',7X,'RESIDUAL',6X,'DEVIATION',6X,
     2 'NO. NON-CONV. NODES')
 3300 FORMAT(5X,I10,3X,E12.4,3X,E12.4,15X,I10)
 3500 FORMAT('0','WARING: NON-CONVERGENCE OCCUR DURING STEADY STATE',
     1 ' SOLUTION AT',I3,' -TH CYCLE'/1H ,'IT = ',I3,'  .GT.  MAXIT = ',
     2 I3,',  RES =',D12.5,',  RD =',D12.4,',  NNCVN =',I4)
 3700 FORMAT(//'TABLE OF RAINFALL/EVAPORATION-SEEPAGE B. C. USED FOR',
     1 I3,'-TH CYCLE'//6X,' I  NPRB NPCON     HCON    NPMIN    HMIN',
     2 ' NPFLX       FLX         DCYFLX')
 3710 FORMAT(' ',I6,I6,I6,D12.4,I6,D12.4,I6,2D12.4)
 3900 FORMAT('0','ABSOLUTELY WARNING: STEADY STATE SOLUTION IS NG'/' ',
     1 'ICY = ',I3,'  IT = ',I3,'  MAXCY = ',I3,'  MAXIT = ',I3,
     2 ',  RES =',D12.4,',  RD =',D12.4,',  NNCVN =',I4)
 3910 FORMAT('0 *** GREAT! STEADY STATE SOLUTION IS ACHIEVED AT',
     1 I3,'-TH CYCLE',I4,'-TH ITERATIONS')
 6500 FORMAT('0','WARNING: NON-CONVERGENCE OCCUR AT',I5,' -TH TIME STEP'
     1 ,I3,' -TH CYCLE'/1H ,'IT = ',I3,'  .GT.  MAXIT = ',I3,2D12.4,I5)
 6900 FORMAT('0','ABSOLUTELY WARNING: TRANSIENT SOLUTION IS NG AT ',I5,
     1 ' -TH TIME STEP'/1H ,'ICY = ',I3,'  IT = ',I3,'  MAXCY = ',I3,
     2 ' MAXIT = ',I3,',  RES =',D12.4,',  RD =',D12.4,',  NNCVN =',I4)
 6910 FORMAT('0  *** GREAT! TRANSIENT SOLUTION IS CONVERGENT FOR',I5,
     1 '-TH TIME STEP'/1X,' *** AT ',I3,'-TH CYCLE',I3,'-TH ITERATION')
C
      END
c
c
c
      SUBROUTINE FASEMB
     I  (COORD,IE,LRN,NLRN, HP,TH,DTH,AKHC,RHOM, SOSH,ISTYPH,WSSH,
     I   IWTYPH, C,LRL,NLRL,PROP,DINTS,RHOMU, IRHO, SOS,ISTYP,WSS,IWTYP,
     O   CMATRX,RLD)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO ASSEMBLE THE GLOBAL COEFFICIENT MATRIX AND LOAD VECTOR.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
C
      COMMON /TIMER/ DELT,CHNG,DELMAX,TMAX,DELTO,TIME
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
      COMMON /HRCNT/ TOLAH,TOLBH,WF,OMEH,OMIH,CNSTKR
C
      COMMON /HELS/ MXSELH,MXSPRH,MXSDPH,NSELH,NSPRH,NSDPH,KSAIH
      COMMON /HNPS/ MXWNPH,MXWPRH,MXWDPH,NWNPH,NWPRH,NWDPH,KWAIH
      COMMON /TELS/ MXSEL,MXSPR,MXSDP,NSEL,NSPR,NSDP,KSAI
      COMMON /TNPS/ MXWNP,MXWPR,MXWDP,NWNP,NWPR,NWDP,KWAI
      COMMON /CHEM/ MXNCC,NCC
C
      DIMENSION CMATRX(MXADNP,MAXBW),RLD(MXADNP),C(MAXNP,MXNCC)
      DIMENSION COORD(MAXNP,2),IE(MAXEL,9),LRN(MXJBD,MXADNP),NLRN(MAXNP)
      DIMENSION LRL(MXKBD,MAXNP),NLRL(MAXNP),PROP(MAXMAT,MXMPPM)
      DIMENSION HP(MAXNP),TH(MAXEL,4),DTH(MAXEL,4),AKHC(4,MAXEL,3)
      DIMENSION RHOM(4,MAXEL), SOSH(MXSPRH),ISTYPH(MXSELH,2)
      DIMENSION WSSH(MXWPRH),IWTYPH(MXWNPH,2)
      DIMENSION ISTYP(MXSEL,MXNCC),SOS(MXSPR,2)
      DIMENSION IWTYP(MXWNP,MXNCC),WSS(MXWPR,2)
      DIMENSION DINTS(MXNCC),RHOMU(MXNCC)
C
c      DIMENSION QA(4,4),QB(4,4),RQ(4),THG(4),DTHG(4),AKXG(4),AKZG(4),
      DIMENSION QA(4,4),QB(4,4),RQ(4),DTHG(4),AKXG(4),AKZG(4),
     1 AKXZG(4),XQ(4),ZQ(4),IEM(4),RHOQ(4),CKG(7)
C
      AGRAV=DBLE(KGRAV)
C
      DELTI=1.D0/DELT
      W1=WF
      W2=1.0D0-WF
      IF(KSSH.EQ.0) THEN
        DELTI=0.0
        W1=1.0D0
        W2=0.0
      ELSEIF(IMID.EQ.1)THEN
        W1=1.0D0
        W2=0.0D0
      ENDIF
C
C ------- INITIATE MATRICES CMATRX(NP,IB) AND RLD(NP)
C
  100 IF(IPNTS.EQ.1) GO TO 140
      DO 110 NP=1,NNP
      RLD(NP)=0.0
      DO 110 IB=1,IHBP
      CMATRX(NP,IB)=0.0
  110 CONTINUE
      GO TO 190
  140 DO 145 NP=1,NNP
      RLD(NP)=0.0
      DO 145 I=1,MAXBW
      CMATRX(NP,I)=0.0
  145 CONTINUE
  190 CONTINUE
C
C ------- START TO ASSEMBLE OVER ALL ELEMENTS
C
      DO 690 M=1,NEL
C
      NQ=4
      IEM4=IE(M,4)
      IF(IEM4.EQ.0) NQ=3
C
C ------- COMPUTE MATRICES QA(IQ,JQ), QB(IQ,JQ), AND RQ(IQ) FOR EACH M
C
      MTYP=IE(M,5)
      RHOW=PROP(MTYP,4)
      WSOSM=0.0
      IF(NSELH.EQ.0) GO TO 209
      DO 205 I=1,NSELH
      MP=ISTYPH(I,2)
      IF(MP.NE.M) GO TO 205
      ITYP=ISTYPH(I,1)
      WSOSM=SOSH(ITYP)
      IF(IRHO.EQ.1 .AND. WSOSM.GT.0.0D0)THEN
        DO K=1,NCC
          ITYP=ISTYP(I,K)
          CKG(K)=SOS(ITYP,2)
        ENDDO
        CALL RHOFUN(RHOSTR,AMU,RHOW,DINTS,CKG,RHOMU)
        WSOSM=WSOSM*RHOSTR
      ENDIF
      GO TO 209
  205 CONTINUE
  209 CONTINUE
C
      DO 210 IQ=1,NQ
      NP=IE(M,IQ)
      IEM(IQ)=NP
      XQ(IQ)=COORD(NP,1)
      ZQ(IQ)=COORD(NP,2)
      AKXG(IQ)=AKHC(IQ,M,1)
      AKZG(IQ)=AKHC(IQ,M,2)
      AKXZG(IQ)=AKHC(IQ,M,3)
      RHOQ(IQ)=RHOM(IQ,M)
  210 CONTINUE
C
C     GAMAMU=PROP(MTYP,4)/PROP(MTYP,5)
      DO 220 KG=1,NQ
c      THG(KG)=TH(M,KG)
      DTHG(KG)=DTH(M,KG)
  220 CONTINUE
C
      IF(NQ.EQ.3) CALL FQ3(QA,QB,RQ,DTHG,AKXG,AKZG,AKXZG,RHOQ,XQ,ZQ,
     1 WSOSM, AGRAV)
      IF(NQ.EQ.4) CALL FQ4(QA,QB,RQ,DTHG,AKXG,AKZG,AKXZG,RHOQ,XQ,ZQ,
     1 WSOSM, AGRAV)
C
C ------- ASSEMBLE QA(IQ,JQ) AND QB(IQ,JQ) INTO THE GLOBAL MATRIX
C ------- CMATRX(NP,IB) = B + A/DELT AND FORM THE GLOBAL LOAD VECTOR
C ------- RLD(NNP).  SINCE CMATRX IS SYMMETRIC, ONLY THE UPPER HALF
C ------- BAND IS STORED.
C
      DO 390 IQ=1,NQ
      NI=IEM(IQ)
      RLD(NI)=RLD(NI)-RQ(IQ)
      DO 340 JQ=1,NQ
      NJ=IEM(JQ)
      IF(IMID.EQ.0)THEN
C
C ----- FOR THE CASE OF NON MID-DIFFERENCE
C
        QA(IQ,JQ)=QA(IQ,JQ)*DELTI
      ELSE
C
C ------ FOR THE CASE OF MID-DIFFERENCE : BE SURE TO READ W AS 1.0
C
        QA(IQ,JQ)=QA(IQ,JQ)*DELTI*2.0D0
      ENDIF
      RLD(NI)=RLD(NI)+(QA(IQ,JQ)-W2*QB(IQ,JQ))*HP(NJ)
C
      IF(IPNTS.EQ.1) GO TO 320
C
      IF(NJ.LT.NI) GO TO 340
      IB=NJ-NI+1
      CMATRX(NI,IB)=CMATRX(NI,IB)+QA(IQ,JQ)+W1*QB(IQ,JQ)
      GO TO 340
C
  320 DO 325 I=1,NLRN(NI)
      LNODE=LRN(I,NI)
      IF(NJ.EQ.LNODE) GO TO 330
  325 CONTINUE
C
      WRITE(16,1000) NI,M,JQ
      STOP
C
  330 CMATRX(NI,I)=CMATRX(NI,I)+QA(IQ,JQ)+W1*QB(IQ,JQ)
C
  340 CONTINUE
  390 CONTINUE
  690 CONTINUE
C
C ------- INCORPORATE WELL SOURCE/SINK
C
      IF(NWNPH.EQ.0) GO TO 910
      DO 790 I=1,NWNPH
      NI=IWTYPH(I,2)
      ITYP=IWTYPH(I,1)
      IF(IRHO.EQ.1)THEN
        RHO=0.0D0
        AREAT=0.0D0
        DO J=1,NLRL(NI)
          MP=LRL(J,NI)
          MTYP=IE(MP,5)
          CALL ELENOD(IE(MP,4),NODE)
          CALL AREA(MAXNP,MAXEL,COORD(1,1),COORD(1,2),IE,MP,NODE,
     >              AREAE)
          RHO=RHO+PROP(MTYP,4)*AREAE
          AREAT=AREAT+AREAE
        ENDDO
        RHOW=RHO/AREAT
        WSSK=WSSH(ITYP)
C
        IF(WSSK.LT.0.0D0)THEN
          DO K=1,NCC
            CKG(K)=C(NI,K)
          ENDDO
        ELSEIF(WSSK.GT.0.0D0)THEN
          DO K=1,NCC
            ITYP=IWTYP(I,K)
            CKG(K)=WSS(ITYP,2)
          ENDDO
        ENDIF
        CALL RHOFUN(RHO,AMU,RHOW,DINTS,CKG,RHOMU)
        WSSK=WSSK*RHO
      ENDIF
C
      RLD(NI)=RLD(NI)+WSSK
  790 CONTINUE
C
  910 CONTINUE
C
 1000 FORMAT('1'/5X,'*** WARNING: NONE OF THE SURROUNDING NODE IN EQUA',
     1 'TION',I3/5X,'***  IS CORRESPONDING TO ',I5,'-TH ELEMENT-S',I2,
     2 '-TH NODE; STOP  ****')
C
      RETURN
      END
c
c
c
      SUBROUTINE BASE(N,DNSS,DNTT,SS,TT)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO COMPUTE BASIS FUNCTIONS AND THEIR DERIVATIVES WITH RESPECT
C ------- TO LOCAL COORDINATES.
C
C********1*********2*********3*********4*********5*********6*********7**
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 N(4)
C
      DIMENSION DNSS(4),DNTT(4)
C
      SM=1.0D0-SS
      SP=1.0D0+SS
      TM=1.0D0-TT
      TP=1.0D0+TT
      N(1)=0.25D0*SM*TM
      N(2)=0.25D0*SP*TM
      N(3)=0.25D0*SP*TP
      N(4)=0.25D0*SM*TP
      DNSS(1)=-0.25D0*TM
      DNSS(2)=0.25D0*TM
      DNSS(3)=0.25D0*TP
      DNSS(4)=-0.25D0*TP
      DNTT(1)=-0.25D0*SM
      DNTT(2)=-0.25D0*SP
      DNTT(3)=0.25D0*SP
      DNTT(4)=0.25D0*SM
      RETURN
      END
c
c
c
      SUBROUTINE FBC
c     I    (COORD,IE,LRN,NLRN,AKHC, QCB,ICTYPH,ISCH, QNB,INTYPH,ISNH,
     I    (COORD,LRN,NLRN,AKHC, QCB,ICTYPH,ISCH, QNB,INTYPH,ISNH,
     I     DLCSNH, RSVAB,INDRS,RFALL,IRTYP,DLCSR,ISR, HDB,IDTYPH, RHOM,
     M     CMATRX,RLD)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO INCORPORATE FOUR TYPES OF BOUNDARY CONDITIONS IN SOLVING
C ------- THE RICHARD'S EQUATION.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
C
      COMMON /HCBC/ MXCNPH,MXCESH,MXCPRH,MXCDPH,NCNPH,NCESH,NCPRH,
     >              NCDPH,KCAIH
      COMMON /HNBC/ MXNNPH,MXNESH,MXNPRH,MXNDPH,NNNPH,NNESH,NNPRH,
     >              NNDPH,KNAIH
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
      COMMON /HDBC/ MXDNPH,MXDPRH,MXDDPH,NDNPH,NDPRH,NDDPH,KDAIH
C
      DIMENSION CMATRX(MXADNP,MAXBW),RLD(MXADNP)
c      DIMENSION COORD(MAXNP,2),IE(MAXEL,9),LRN(MXJBD,MXADNP),NLRN(MAXNP)
      DIMENSION COORD(MAXNP,2),LRN(MXJBD,MXADNP),NLRN(MAXNP)
      DIMENSION AKHC(4,MAXEL,3),RHOM(4,MAXEL)
C
      DIMENSION QCB(MXCPRH),ICTYPH(MXCNPH,2),ISCH(5,MXCESH)
      DIMENSION QNB(MXNPRH),INTYPH(MXNNPH,2),ISNH(5,MXNESH),
     >          DLCSNH(3,MXNESH)
      DIMENSION RSVAB(MXRNP,4),INDRS(MXRNP,3),RFALL(MXRPR),
     >          IRTYP(MXRNP,2),DLCSR(3,MXRES),ISR(5,MXRES)
      DIMENSION HDB(MXDPRH),IDTYPH(MXDNPH,2)
C
      DIMENSION RQ(2),RHOQ(2)
C
      AGRAV=DBLE(KGRAV)
C
      IHALFB=(IBAND-1)/2
C
C ******* APPLY CAUCHY BOUNDARY CONDITIONS
C
      IF(NCESH.LE.0) GO TO 300
      DO 160 MP=1,NCESH
      I=ISCH(1,MP)
      M=ISCH(5,MP)
      NI=ICTYPH(I,2)
      J=ISCH(2,MP)
      NJ=ICTYPH(J,2)
      DX=COORD(NI,1)-COORD(NJ,1)
      DZ=COORD(NI,2)-COORD(NJ,2)
      EL=DSQRT(DX*DX+DZ*DZ)
      ITYPI=ICTYPH(I,1)
      ITYPJ=ICTYPH(J,1)
      KQ1=ISCH(3,MP)
      KQ2=ISCH(4,MP)
      RHOQ(1)=RHOM(KQ1,M)
      RHOQ(2)=RHOM(KQ2,M)
      CALL F2CNVB(RQ,EL,QCB(ITYPI),QCB(ITYPJ),RHOQ,VN1,VN2,1)
      RLD(NI)=RLD(NI)+RQ(1)
      RLD(NJ)=RLD(NJ)+RQ(2)
C     RVCTR(NI)=RVCTR(NI)-EL*(QCB(ITYPI)/3.0D0*RHOI+
C    >          QCB(ITYPJ)/6.0D0*RHOJ)
C     RVCTR(NJ)=RVCTR(NJ)-EL*(QCB(ITYPI)/6.0D0*RHOI+
C    >          QCB(ITYPJ)/3.0D0*RHOJ)
  160 CONTINUE
C
C ******* APPLY VARIABLE (RAINFALL-SEEPAGE) BOUNDARY CONDITIONS
C
  300 CONTINUE
      IF(NRNP.EQ.0) GO TO 500
C
C -------- CAUCHY PART OF VARIABLE BOUNDARY CONDITIONS
C
      DO 490 MP=1,NRES
        I=ISR(1,MP)
        NI=IRTYP(I,2)
        J=ISR(2,MP)
        NJ=IRTYP(J,2)
        INI=INDRS(I,1)+INDRS(I,2)
        INJ=INDRS(J,1)+INDRS(J,2)
        IF(INI.NE.0 .AND. INJ.NE.0)GOTO 490
        ITYP=IRTYP(I,1)
        JTYP=IRTYP(J,1)
        RFNI=0.
        RFNJ=0.
        IF(ITYP.GT.0) RFNI=RFALL(ITYP)
        IF(JTYP.GT.0) RFNJ=RFALL(JTYP)
        PROJ=DLCSR(2,MP)
        EL=DLCSR(3,MP)
        RFNI=-RFNI*PROJ
        RFNJ=-RFNJ*PROJ
        M=ISR(5,MP)
        KQ1=ISR(3,MP)
        KQ2=ISR(4,MP)
        RHOQ(1)=RHOM(KQ1,M)
        RHOQ(2)=RHOM(KQ2,M)
        CALL F2CNVB(RQ,EL,RFNI,RFNJ,RHOQ,VN1,VN2,3)
        RLD(NI)=RLD(NI)+RQ(1)
        RLD(NJ)=RLD(NJ)+RQ(2)
  490 CONTINUE
C
C -------- DIRICHLET PART OF VARIABLE BOUNDARY CONDITIONS
C
      IF(IPNTS.EQ.1) GO TO 400
C
      DO 390 NPP=1,NRNP
C
C  $$$$$$$$$$  MODIFY LOAD VECTOR FOR NON-ZERO HCON
C
      NI=INDRS(NPP,1)
      IF(NI.NE.0) GO TO 305
      NI=INDRS(NPP,2)
      IF(NI.NE.0) GO TO 310
      GO TO 390
  305 BB=RSVAB(NPP,1)
      GO TO 315
  310 BB=RSVAB(NPP,2)
C
  315 IF(BB.EQ.0.0) GO TO 340
      DO 320 IB=1,IHALFB
      NJ=NI-IB
      IF(NJ.LT.1) GO TO 325
      JB=IB+1
  320 RLD(NJ)=RLD(NJ)-BB*CMATRX(NJ,JB)
  325 DO 330 IB=1,IHALFB
      NJ=NI+IB
      IF(NJ.GT.NNP) GO TO 340
      JB=IB+1
  330 RLD(NJ)=RLD(NJ)-BB*CMATRX(NI,JB)
  340 RLD(NI)=BB
C
C  $$$$$$$$$$  ZERO COLUMN NPCON(NPP)
C
      DO 350 IB=1,IHALFB
      NJ=NI-IB
      IF(NJ.LT.1) GO TO 360
      JB=IB+1
  350 CMATRX(NJ,JB)=0.0
C
C  $$$$$$$$$$  MODIFY ROW NPCON(NPP)
C
  360 DO 370 KB=1,IHBP
  370 CMATRX(NI,KB)=0.0
      CMATRX(NI,1)=1.0D0
  390 CONTINUE
      GO TO 500
C
  400 DO 440 NPP=1,NRNP
      NI=INDRS(NPP,1)
      IF(NI.NE.0) GO TO 405
      NI=INDRS(NPP,2)
      IF(NI.NE.0) GO TO 410
      GO TO 440
  405 BB=RSVAB(NPP,1)
      GO TO 415
  410 BB=RSVAB(NPP,2)
C
  415 RLD(NI)=BB
C ----- modify the row corresponding to the head node
      DO 430 I=1,NLRN(NI)
      CMATRX(NI,I)=0.0
      LNODE=LRN(I,NI)
      IF(LNODE.EQ.NI) CMATRX(NI,I)=1.0D0
  430 CONTINUE
c ----- modify the column corresponding to the head node; the reason
c ----- of this is to make the coefficient matrix symmetric
      DO 437 INP=1,NLRN(NI)
        NP=LRN(INP,NI)
        IF(NP.EQ.NI .OR. NP.EQ.0)GOTO 437
        DO 435 IP=1,NLRN(NP)
          IB=LRN(IP,NP)
          IF(IB.EQ.0)GOTO 435
          IF(IB.EQ.NI)THEN
            RLD(NP)=RLD(NP)-CMATRX(NP,IP)*RLD(NI)
            CMATRX(NP,IP)=0.0D0
            GOTO 437
          ENDIF
  435   CONTINUE
  437 CONTINUE
  440 CONTINUE
C
C ******* APPLY NEUMANN BOUNDARY CONDITIONS
C
  500 CONTINUE
      IF(NNNPH.EQ.0) GO TO 600
      DO 530 MP=1,NNESH
      I=ISNH(1,MP)
      NI=INTYPH(I,2)
      J=ISNH(2,MP)
      NJ=INTYPH(J,2)
C
C -------- MODIFY LOAD VECTOR DUE TO NEUMANN FLUX
C
      EL=DLCSNH(3,MP)
      ITYPI=INTYPH(I,1)
      ITYPJ=INTYPH(J,1)
C     RVCTR(NI)=RVCTR(NI)-EL*(QNB(ITYPI)/3.0D0+
C    >          QNB(ITYPJ)/6.0D0)
C     RVCTR(NJ)=RVCTR(NJ)-EL*(QNB(ITYPI)/6.0D0+
C    >          QNB(ITYPJ)/3.0D0)
C
C -------- MODIFY GRAVITY FLUX DUE TO GRAVITY TERM
C
      M=ISNH(5,MP)
c      MTYP=IE(M,5)
C     GAMAMU=PROP(MTYP,4)/PROP(MTYP,5)
c      NQ=4
c      IEM4=IE(M,4)
c      IF(IEM4.EQ.0) NQ=3
C
      KQ1=ISNH(3,MP)
      KQ2=ISNH(4,MP)
C     KQ1=INTYPH(I,2)
C     KQ2=INTYPH(J,2)
C
      RHOQ(1)=RHOM(KQ1,M)
      RHOQ(2)=RHOM(KQ2,M)
      VN1=(DLCSNH(1,MP)*AKHC(KQ1,M,3)+DLCSNH(2,MP)*AKHC(KQ1,M,2))*AGRAV
      VN2=(DLCSNH(1,MP)*AKHC(KQ2,M,3)+DLCSNH(2,MP)*AKHC(KQ2,M,2))*AGRAV
C
      CALL F2CNVB(RQ,EL,QNB(ITYPI),QNB(ITYPJ),RHOQ,VN1,VN2,2)
C
      RLD(NI)=RLD(NI)+RQ(1)
      RLD(NJ)=RLD(NJ)+RQ(2)
  530 CONTINUE
C
C ******* APPLY DIRICHLET BOUNDARY CONDITIONS
C
  600 IF(NDNPH.LE.0) GO TO 900
C
      IF(IPNTS.EQ.1) GO TO 700
      DO 690 NPP=1,NDNPH
C
C -------- MODIFY LOAC VECTOR FOR NON-ZERO DIRICHLET BOUNDARY VALUES
C
      NI=IDTYPH(NPP,2)
      ITYP=IDTYPH(NPP,1)
      BB=HDB(ITYP)-COORD(NI,2)*AGRAV
C
      IF(BB.EQ.0.0) GO TO 640
      DO 610 IB=1,IHALFB
      NJ=NI-IB
      IF(NJ.LT.1) GO TO 620
      JB=IB+1
      RLD(NJ)=RLD(NJ) - BB*CMATRX(NJ,JB)
  610 CONTINUE
  620 DO 630 IB=1,IHALFB
      NJ=NI+IB
      IF(NJ.GT.NNP) GO TO 640
      JB=IB+1
      RLD(NJ)=RLD(NJ)-BB*CMATRX(NI,JB)
  630 CONTINUE
C
  640 RLD(NI)=BB
C
C -------- ZERO COLUMN NPDB(NPP)
C
      DO 650 IB=1,IHALFB
      NJ=NI-IB
      IF(NJ.LT.1) GO TO 660
      JB=IB+1
      CMATRX(NJ,JB)=0.0
  650 CONTINUE
C
C -------- MODIFY ROW NPDB(NPP)
C
  660 DO 670 KB=1,IHBP
      CMATRX(NI,KB)=0.0
  670 CONTINUE
      CMATRX(NI,1)=1.0D0
  690 CONTINUE
      GO TO 900
C
  700 DO 720 NPP=1,NDNPH
      NI=IDTYPH(NPP,2)
      ITYP=IDTYPH(NPP,1)
      BB=HDB(ITYP)-COORD(NI,2)*AGRAV
C ----- put the Dirichlet head on the RHS
      RLD(NI)=BB
C ----- modify the row corresponding to the Dirichlet node
      DO 710 I=1,NLRN(NI)
      CMATRX(NI,I)=0.0
      LNODE=LRN(I,NI)
      IF(LNODE.EQ.NI) CMATRX(NI,I)=1.0D0
  710 CONTINUE
C ----- modify the column corresponding to the Dirichlet node.
C ----- the reason for this is to make the matrix symmetric
      DO 717 INP=1,NLRN(NI)
        NP=LRN(INP,NI)
        IF(NP.EQ.NI .OR. NP.EQ.0)GOTO 717
        DO 715 IP=1,NLRN(NP)
          IB=LRN(IP,NP)
          IF(IB.EQ.0)GOTO 715
          IF(IB.EQ.NI)THEN
            RLD(NP)=RLD(NP)-CMATRX(NP,IP)*RLD(NI)
            CMATRX(NP,IP)=0.0D0
            GOTO 717
          ENDIF
  715   CONTINUE
  717 CONTINUE
  720 CONTINUE
C
  900 CONTINUE
C
      RETURN
      END
c
c
c
      SUBROUTINE BCPREP
     I    (H,VELOC,RFALL,IRTYP,DLCSR,ISR,
     O     NCHG,
     M     RSVAB,INDRS)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO CHECK IF CHANGE OVER OF BOUNDARY CONDITIONS IS NECESSARY?
C ------- ALSO TO PREPARE BOUNDARY CONDITIONS IF CHANGE OVER IS NEEDED.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
C
      COMMON /TIMER/ DELT,CHNG,DELMAX,TMAX,DELT0,TIME
C
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
C
      DIMENSION H(MAXNP),VELOC(MAXNP,2)
C
      DIMENSION RFALL(MXRPR),IRTYP(MXRNP,2)
      DIMENSION DLCSR(3,MXRES),ISR(5,MXRES)
      DIMENSION RSVAB(MXRNP,4),INDRS(MXRNP,3)
C
C ------- DETERMINE NORMAL RAINFALLS FLX(I) AND DARCY FLUXES DCYFLX(I)
C ------- FOR EACH RAINFALL-SEEPAGE NODAL POINT.
C
  200 DO 210 NP=1,NRNP
      RSVAB(NP,3)=0.0
  210 RSVAB(NP,4)=0.0
C
      DO 290 MP=1,NRES
      I=ISR(1,MP)
      J=ISR(2,MP)
      NI=IRTYP(I,2)
      NJ=IRTYP(J,2)
C
      ITYP=IRTYP(I,1)
      JTYP=IRTYP(J,1)
      RFNI=0.
      RFNJ=0.
      IF(ITYP.GT.0) RFNI=RFALL(ITYP)
      IF(JTYP.GT.0) RFNJ=RFALL(JTYP)
C
C ------- OBTAIN RAINFALL RATES RFNI AND RFNJ AT POINTS NI AND NJ NORMAL
C ------- TO THE SIDE SUBTENDED BY THESE POINTS
C
      PROJ=DLCSR(2,MP)
      RFNI=-RFNI*PROJ
      RFNJ=-RFNJ*PROJ
C
C ------- CALCULATE RAINFALL FLUX PASSING THROUGH SIDE (NI,NJ) AND
C ------- DIVIDE IT INTO TWO PARTS FLX(I) AND FLX(J).  PERFORM A SIMILAR
C ------- OPERATION TO OBTAIN DARCY FLUXES DCYFLX(I) AND DCYFLX(J).
C
      RSVAB(I,3)=RSVAB(I,3)+(RFNI/3.0D0+RFNJ/6.0D0)*DLCSR(3,MP)
      RSVAB(J,3)=RSVAB(J,3)+(RFNI/6.0D0+RFNJ/3.0D0)*DLCSR(3,MP)
C
C ------- COMPUTE THE DARCY'S FLUXES THROUGH POINTS NI AND NJ USING THE
C ------- WHOLE BOUNDARY LENGTH.
C
      FNI=(VELOC(NI,1)*DLCSR(1,MP)+VELOC(NI,2)*DLCSR(2,MP))*DLCSR(3,MP)
      FNJ=(VELOC(NJ,1)*DLCSR(1,MP)+VELOC(NJ,2)*DLCSR(2,MP))*DLCSR(3,MP)
C
C ------- DISTRIBUTE THE ABOVE FLUXES TO TWO END POINTS OF THE SIDE
C
      RSVAB(I,4)=RSVAB(I,4)+FNI/3.0D0+FNJ/6.0D0
      RSVAB(J,4)=RSVAB(J,4)+FNJ/3.0D0+FNI/6.0D0
C
  290 CONTINUE
C
C ------- CHANGE TO FLUX OR HEAD CONDITIONS, AS NECESSARY, AND SO
C ------- INDICATE IN THE ARRAYS NPFLX(NPP) AND NPCON(NPP).
C
      IF (NCHG.NE.(-1)) GO TO 300
      NCHG=0
      RETURN
C
  300 NCHG=0
C
      DO 390 NPP=1,NRNP
C
      DCYNNP=RSVAB(NPP,4)
      FLXNNP=RSVAB(NPP,3)
      HCONNP=RSVAB(NPP,1)
      HMINNP=RSVAB(NPP,2)
C
      IF(FLXNNP.GT.0.0) GO TO 350
C
C **** RAINFALL(INFILTRATION)-SEEPAGE CONDITIONS PREVAIL DURING RAINFALL
C
C
C ------- CHECK IF THE CHANGE FROM RAINFALL-FLUX (CAUCHY) CONDITION TO
C ------- PONDING (DIRICHLET) CONDITION IS NECESSARY?
C
      NP=INDRS(NPP,3)
      IF (NP.EQ.0) GO TO 310
      IF(HCONNP.GE.H(NP)) GO TO 390
      INDRS(NPP,1)=INDRS(NPP,3)
      INDRS(NPP,3)=0
      NCHG=NCHG+1
      GO TO 390
C
C ------- CHECK IF THE CHANGE FROM PONDING (DIRICHLET) CONDITION TO
C ------- RAINFALL-FLUX (NEUMANN) CONDITION IS NECESSARY?
C
  310 NP=INDRS(NPP,1)
      IF(NP.EQ.0) GO TO 320
      IF(FLXNNP.LE.DCYNNP) GO TO 390
      INDRS(NPP,3)=INDRS(NPP,1)
      INDRS(NPP,1)=0
      NCHG=NCHG+1
      GO TO 390
C
C ------- CHANGE MINIMUM PRESSURE CONDITION TO RAINFALL-FLUX CONDITION
C ------- SINCE A MINIMUM PRESSURE CONDITION IS NOT LIKELY TO BE
C ------- DURING RAINFALL PERIOD
C
  320 NP=INDRS(NPP,2)
      IF(NP.EQ.0) GO TO 390
      INDRS(NPP,3)=INDRS(NPP,2)
      INDRS(NPP,2)=0
      NCHG=NCHG+1
      GO TO 390
C
C **** EVAPORATION-SEEPAGE CONDITIONS PREVAIL DURING NON-RAINFALL PERIOD
C
C
C ------- CHECK IF THE CHANGE FROM EVAPORATION-FLUX CONDITION TO
C ------- MINIMUM PRESSURE HEAD CONDITION IS NECESSARY?
C
  350 NP=INDRS(NPP,3)
      IF(NP.EQ.0) GO TO 360
      IF(HMINNP.LE.H(NP)) GO TO 390
      INDRS(NPP,2)=INDRS(NPP,3)
      INDRS(NPP,3)=0
      NCHG=NCHG+1
      GO TO 390
C
C ------- CHECK IF THE CHANGE FROM PONDING CONDITION TO EVAPORATION-FLUX
C ------- CONDITION IS NECESSARY?
C
  360 NP=INDRS(NPP,1)
      IF(NP.EQ.0) GO TO 370
      IF(DCYNNP.GE.0.0) GO TO 390
      INDRS(NPP,3)=INDRS(NPP,1)
      INDRS(NPP,1)=0
      NCHG=NCHG+1
      GO TO 390
C
C ------- CHECK IF THE CHANGE FROM MINIMUM PRESSURE HEAD CONDITION TO
C ------- EVAPORATION-FLUX CONDITION IS NECESSARY?
C
  370 NP=INDRS(NPP,2)
      IF(NP.EQ.0) GO TO 390
C      IF(DCYNNP.LT.0.0) GO TO 380
      IF(DCYNNP.LT.FLXNNP) GO TO 390
      INDRS(NPP,3)=INDRS(NPP,2)
      INDRS(NPP,2)=0
      NCHG=NCHG+1
C     GO TO 390
C
C 380 WRITE(16,1000) NPP
C     STOP
C
  390    CONTINUE
C
C1000 FORMAT('1','*** WARNING DURING NON-RAINFALL PERIOD',I3,
C   1 '-TH VB NODE USING MINIMUM HEAD CONDITION RESULTS IN ',
C   2 'DARCY FLUX INTO THE REGION'/1X,'THIS SHOULD NOT HAPPEN. ',
C   3 'HENCE EITHER MINIMUM HEAD IS NOT SMALL ENOUGH OR THE INTERIOR ',
C   4 'NODE PRESSURE IS TOO SMALL: STOP')
      RETURN
      END
c
c
c
      SUBROUTINE FPRINT(H,HT,TH,VELOC,NPBB,BFLX,NPVB,RSVAB,INDRS,
     >                  SUBHD, KPR,ITM,KOUT,KDIAG)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO PRINT PRESSURE, TOTAL HEAD, MOISTURE CONTENT, AND VELOCITY
C ------- COMPONENTS AS NEEDED.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*4 SUBHD
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
      COMMON /FFLOW/ FRATE(10),FLOW(10),TFLOW(10)
C
      COMMON /TIMER/ DELT,CHNG,DELMAX,TMAX,DELT0,TIME
C
      DIMENSION H(MAXNP),HT(MAXNP),TH(MAXEL,4),VELOC(MAXNP,2)
      DIMENSION NPBB(MAXBNP),BFLX(MAXBNP,2),NPVB(MXRNP)
      DIMENSION RSVAB(MXRNP,4),INDRS(MXRNP,3)
C
      DIMENSION SUBHD(8)
C
      IF(KPR.EQ.0) RETURN
C ----- print diagnostic flow information
        KDIAG=KDIAG+1
        KDIA=KDIAG-1
        WRITE(16,1000) KDIA,TIME,DELT,ITM,(FRATE(I),FLOW(I),
     >   TFLOW(I), I=1,9)
        IF(NRNP.GT.0) THEN
          DO 120 NPP=1,NRNP
            NP=NPVB(NPP)
            DO 115 I=1,NBNP
              IJ=NPBB(I)
              IF(IJ.NE.NP) GO TO 115
              NKK=I
              GO TO 120
  115       CONTINUE
  120     RSVAB(NPP,4)=BFLX(NKK,2)
          WRITE(16,1100)
          WRITE(16,1110) (RSVAB(NPP,4),NPP=1,NRNP)
          WRITE(16,1120) (INDRS(NPP,1),NPP=1,NRNP)
          WRITE(16,1125) (INDRS(NPP,2),NPP=1,NRNP)
          WRITE(16,1130) (INDRS(NPP,3),NPP=1,NRNP)
        END IF
C
C ------- PRINT PRESSURE HEADS
C
      KOUT=KOUT+1
      LINE=0
      DO 210 NI=1,NNP,5
      NJMN=NI
      NJMX=MIN0(NI+4,NNP)
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,2000) KOUT,TIME,DELT,IBAND,ITM,
     1 (SUBHD(I),I=1,8)
  210 WRITE(16,2100) NI,(H(NJ),NJ=NJMN,NJMX)
      IF(KPR.EQ.1) RETURN
C
C ------- PRINT TOTAL HEADS
C
      KOUT=KOUT+1
      LINE=0
      DO 310 NI=1,NNP,5
      NJMN=NI
      NJMX=MIN0(NI+4,NNP)
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,3000) KOUT,TIME,DELT,IBAND,ITM,
     1 (SUBHD(I),I=1,8)
  310 WRITE(16,2100) NI,(HT(NJ),NJ=NJMN,NJMX)
      IF(KPR.EQ.2) RETURN
C
C ------- PRINT WATER CONTENTS
C
      KOUT=KOUT+1
      LINE=0
      DO 410 M=1,NEL,2
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,4000) KOUT,TIME,DELT,IBAND,ITM,
     1 (SUBHD(I),I=1,8)
      MJMN=M
      MJMX=MIN0(M+1,NEL)
  410 WRITE(16,4100) (MJ,(TH(MJ,IQ),IQ=1,4),MJ=MJMN,MJMX)
      IF(KPR.EQ.3) RETURN
C
C ------- PRINT DARCY VELOCITIES
C
      KOUT=KOUT+1
      LINE=0
      DO 510 NP=1,NNP,2
      LINE=LINE+1
      IF(MOD(LINE-1,50).EQ.0) WRITE(16,5000) KOUT,TIME,DELT,IBAND,ITM,
     1 (SUBHD(I),I=1,8)
      NJMN=NP
      NJMX=MIN0(NP+1,NNP)
  510 WRITE(16,5100) (NJ,VELOC(NJ,1),VELOC(NJ,2),NJ=NJMN,NJMX)
C
      RETURN
C
 1000 FORMAT(1X//' TABLE OF SYSTEM-FLOW PARAMETERS',2X,'TABLE: ',I4,
     > '.. AT TIME =',1PD12.4/'  (DELT =',1PD12.4,')',' ITIM=',I4//5X,
     > ' TYPE OF FLOW', 2X,'RATE(L**3/T/L)',3X,'INC. FLOW(L**3/L)',4X,
     > 'TOTAL FLOW(L**3/L)'/5X,
     1 40H  1. FLOW THROUGH DIRICHLET NODES .. . .,3(E10.2, 1X)/5X,
     2 40H  2. FLOW THROUGH CAUCHY NODES . . . . .,3(E10.2, 1X)/5X,
     3 40H  3. FLOW THROUGH NEUMANN NODES .  . . .,3(E10.2, 1X)/5X,
     4 40H  4. FLOW THROUGH SEEPAGE NODES .. . . .,3(E10.2, 1X)/5X,
     5 40H  5. FLOW THROUGH INFILTRATION NODES . .,3(E10.2, 1X)/5X,
     6 40H  6. FLOW THROUGH UNSPECIFIED NODES  . .,3(E10.2, 1X)/5X,
     7 40H  7. NET FLOW THROUGH ENTIRE BOUNDARY  .,3(E10.2, 1X)/5X,
     8 40H  8. ARTIFICIAL SOURCES/SINKS . . . .   ,3(E10.2, 1X)/5X,
     9 40H  9. INCREASE IN WATER CONTENT . . . . .,3(E10.2, 1X)/5X,
     A ' *** NOTE: (+) = OUT FROM, (-) = INTO THE REGION. '//)
 1100 FORMAT(/50H RAINFALL-SEEPAGE NODAL FLOWS (((L**3/T)/L**2).L).)
 1110 FORMAT(1H ,5D15.5)
 1120 FORMAT(1H0,16H VALUES OF NPCON/(10I5))
 1125 FORMAT(1H0,16H VALUES OF NPMIN/(10I5))
 1130 FORMAT(1H0,16H VALUES OF NPFLX/(10I5))
 2000 FORMAT(//'1 OUTPUT TABLE',I4,'.. PRESSURE HEADS(L) AT TIME =',
     1 1PD10.3,', (DELT =',1PD10.3,')'/' (BAND WIDTH =',I4,')',
     2 '  ITIM=',I5//1X,8A4//1X,
     3 ' NODE I',5X,'PRESSURE HEAD (L) OF NODES I,I+1,..,I+4')
 2100 FORMAT(I7,5(1PD14.4))
 3000 FORMAT(/'1 OUTPUT TABLE',I4,'.. TOTAL HEADS(L) AT TIME =',1PD10.3,
     1 ', (DELT =',1PD10.3,')'/' (BAND WIDTH =',I4,')','  ITIM =',I5//
     > 1X,8A4
     2 /1X,' NODE I',5X,'TOTAL HEAD (L) OF NODES I,I+1,...,I+4')
 4000 FORMAT(/'1OUTPUT TABLE',I4,'.. WATER CONTENT   AT TIME =',
     1 1PD10.3,', (DELT =',1PD10.3,')'/' (BAND WIDTH =',I4,')',
     2 '  ITIM=',I5//1X/8A4/30X,' GAUSSIAN POINTS'/
     3 17X,'1',11X,'2',11X,'3',11X,'4',6X/3X,'ELEMENT',2X,
     4 '----------------------------------------------'/)
 4100 FORMAT(' ',1X,2(I5,4F8.5,2X))
 5000 FORMAT(/' OUTPUT TABLE',I3,'. DARCY VELOCITIES (L/T) AT TIME =',
     1 1PD10.3,', (DELT =',1PD10.3,')'/' (BAND WIDTH =',I4,')',' ITIM=',
     2 I5//1X,8A4/2X,'NODE',9X,'VX',9X,'VZ',4X,'NODE',9X,'VX',9X,'VZ'/
     5 '----------------------------- -----------------------------'/)
 5100 FORMAT(' ',2(I5,1PD12.4,1PD12.4,3X))
      END
c
c
c
      SUBROUTINE FQ3D(QB,QRX,QRZ,XQ,ZQ,AKXQ,AKZQ,AKXZQ,HQ,RHOQ,AGRAV)
C
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 N(3),L1(3),L2(3),L3(3),LL1(3),LL2(3),LL3(3),L1KG,L2KG,L3KG
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
      DIMENSION QB(4,4),QRX(4),QRZ(4)
      DIMENSION XQ(4),ZQ(4),HQ(4),AKXQ(4),AKZQ(4),AKXZQ(4),RHOQ(4)
      DIMENSION A(3),B(3),C(3), DNX(3),DNZ(3), WG(3)
C
      DATA L1/0.666666666666667D0, 0.166666666666667D0,
     1        0.166666666666667D0/
      DATA L2/0.166666666666667D0, 0.666666666666667D0,
     1        0.166666666666667D0/
      DATA L3/0.166666666666667D0, 0.166666666666667D0,
     1        0.666666666666667D0/
      DATA LL1/1.0D0,0.0D0,0.0D0/
      DATA LL2/0.0D0,1.0D0,0.0D0/
      DATA LL3/0.0D0,0.0D0,1.0D0/
      DATA WG/0.333333333333333D0, 0.333333333333333D0,
     1        0.333333333333333D0/
C
      DO 110 IQ=1,4
      QRX(IQ)=0.0
      QRZ(IQ)=0.0
      DO 110 JQ=1,4
      QB(IQ,JQ)=0.0
  110 CONTINUE
C
      X1=XQ(1)
      X2=XQ(2)
      X3=XQ(3)
      Z1=ZQ(1)
      Z2=ZQ(2)
      Z3=ZQ(3)
C
      A(1)=X2*Z3 - X3*Z2
      A(2)=X3*Z1 - X1*Z3
      A(3)=X1*Z2 - X2*Z1
C
      AREA2=DABS(A(1)+A(2)+A(3))
      AREA=AREA2/2.0D0
C
      B(1)=(Z2-Z3)/AREA2
      B(2)=(Z3-Z1)/AREA2
      B(3)=(Z1-Z2)/AREA2
      C(1)=(X3-X2)/AREA2
      C(2)=(X1-X3)/AREA2
      C(3)=(X2-X1)/AREA2
C
C ------- SUMMATION OF THE INTEGRAND OVER THE GAUSSIAN POINTS
C
      DO 490 KG=1,3
C
C ------- DETERMINE NATURAL COORDINATE (L1,L2,L3) OF GAUSSIAN POINT KG
C
        IF(IQUAR.EQ.11 .OR. IQUAR.EQ.21)THEN
          L1KG=LL1(KG)
          L2KG=LL2(KG)
          L3KG=LL3(KG)
        ELSE
          L1KG=L1(KG)
          L2KG=L2(KG)
          L3KG=L3(KG)
        ENDIF
C
C ------- CALCULATE VALUES OF BASIS FUNCTIONS N(IQ) AND THEIR
C ------- DERIVATIVES DNX(IQ) AND DNZ(IQ) W.R.T. X AND Z, RESPECTIVELY
C ------- AT THE GAUSSIAN POINT KG.
C
        N(1)=L1KG
        N(2)=L2KG
        N(3)=L3KG
        DNX(1)=B(1)
        DNX(2)=B(2)
        DNX(3)=B(3)
        DNZ(1)=C(1)
        DNZ(2)=C(2)
        DNZ(3)=C(3)
C
C       RR=0.0
C       DO 270 IQ=1,3
C         RR=RR+XQ(IQ)*N(IQ)
C 270   CONTINUE
C
        R=1.0D0*WG(KG)*AREA
C       IF(CYLIND.NE.0.0) R=RR*WG(KG)*AREA
C
          AKXK=AKXQ(KG)
          AKZK=AKZQ(KG)
          AKXZK=AKXZQ(KG)
          RHOMK=RHOQ(KG)
C
C ------- ACCUMULATE THE SUMS TO OBTAIN THE MATRIX INTEGRALS QB(IQ,JQ)
C ------- AND QRX(IQ) & QRZ(IQ)
C
        DO 390 IQ=1,3
          QRX(IQ)=QRX(IQ)-N(IQ)*AKXZK*R*AGRAV
          QRZ(IQ)=QRZ(IQ)-N(IQ)*AKZK*R*AGRAV
          DO 340 JQ=1,3
            QB(IQ,JQ)=QB(IQ,JQ)+ N(IQ)*N(JQ)*R
            QRX(IQ)=QRX(IQ)-N(IQ)*HQ(JQ)*(AKXK*DNX(JQ)+AKXZK*DNZ(JQ))*R
     >              /RHOMK
            QRZ(IQ)=QRZ(IQ)-N(IQ)*HQ(JQ)*(AKXZK*DNX(JQ)+AKZK*DNZ(JQ))*R
     >              /RHOMK
  340     CONTINUE
  390   CONTINUE
C
  490 CONTINUE
C
      RETURN
      END
c
c
c
      SUBROUTINE FQ3(QA,QB,RQ,DTHG,AKXQ,AKZQ,AKXZQ,RHOQ,XQ,ZQ,WSOSM,
     1 AGRAV)
C
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 N(3),L1(3),L2(3),L3(3),LL1(3),LL2(3),LL3(3),L1KG,L2KG,L3KG
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
      DIMENSION QA(4,4),QB(4,4),RQ(4),RHOQ(4)
      DIMENSION AKXQ(4),AKZQ(4),AKXZQ(4),XQ(4),ZQ(4),DTHG(4)
      DIMENSION A(3),B(3),C(3), DNX(3),DNZ(3),WG(3)
C
      DATA L1/0.666666666666667D0, 0.166666666666667D0,
     1        0.166666666666667D0/
      DATA L2/0.166666666666667D0, 0.666666666666667D0,
     1        0.166666666666667D0/
      DATA L3/0.166666666666667D0, 0.166666666666667D0,
     1        0.666666666666667D0/
      DATA LL1/1.0D0,0.0D0,0.0D0/
      DATA LL2/0.0D0,1.0D0,0.0D0/
      DATA LL3/0.0D0,0.0D0,1.0D0/
      DATA WG/0.333333333333333D0, 0.333333333333333D0,
     1        0.333333333333333D0/
C
      DO 110 IQ=1,4
      RQ(IQ)=0.0
      DO 110 JQ=1,4
      QA(IQ,JQ)=0.0
      QB(IQ,JQ)=0.0
  110 CONTINUE
C
      X1=XQ(1)
      X2=XQ(2)
      X3=XQ(3)
      Z1=ZQ(1)
      Z2=ZQ(2)
      Z3=ZQ(3)
C
      A(1)=X2*Z3 - X3*Z2
      A(2)=X3*Z1 - X1*Z3
      A(3)=X1*Z2 - X2*Z1
C
      AREA2=DABS(A(1)+A(2)+A(3))
      AREA=AREA2/2.0D0
C
      B(1)=(Z2-Z3)/AREA2
      B(2)=(Z3-Z1)/AREA2
      B(3)=(Z1-Z2)/AREA2
      C(1)=(X3-X2)/AREA2
      C(2)=(X1-X3)/AREA2
      C(3)=(X2-X1)/AREA2
C
      DO 490 KG=1,3
C
C ------- DETERMINE NATURAL COORDINATE (L1,L2,L3) OF GAUSSIAN POINT KG
C
        IF(IQUAR.EQ.11 .OR. IQUAR.EQ.21)THEN
          L1KG=LL1(KG)
          L2KG=LL2(KG)
          L3KG=LL3(KG)
        ELSE
          L1KG=L1(KG)
          L2KG=L2(KG)
          L3KG=L3(KG)
        ENDIF
C
C ------- CALCULATE VALUES OF BASIS FUNCTIONS N(IQ) AND THEIR
C ------- DERIVATIVES DNX(IQ) AND DNZ(IQ) W.R.T. X AND Z, RESPECTIVELY
C ------- AT THE GAUSSIAN POINT KG.
C
        N(1)=L1KG
        N(2)=L2KG
        N(3)=L3KG
        DNX(1)=B(1)
        DNX(2)=B(2)
        DNX(3)=B(3)
        DNZ(1)=C(1)
        DNZ(2)=C(2)
        DNZ(3)=C(3)
C
C       R=0.0
C       DO 270 IQ=1,3
C         R=R+XQ(IQ)*N(IQ)
C 270   CONTINUE
        RR=1.0D0*AREA*WG(KG)
C       IF(CYLIND.NE.0.0) RR=R*AREA*WG(KG)
C
          AKXK=AKXQ(KG)
          AKXZK=AKXZQ(KG)
          AKZK=AKZQ(KG)
          RHOK=RHOQ(KG)
C
        DTHQP=DTHG(KG)*RHOK
C
C ------- ACCUMULATE THE SUMS TO OBTAIN THE MATRIX INTEGRALS QA(IQ,JQ),
C ------- QB(IQ,JQ), AND RQ(IQ)
C
        FHP=DTHQP*RR
        AKXK=AKXK*RR
        AKXZK=AKXZK*RR
        AKZK=AKZK*RR
        WSOSK=WSOSM*RR
        IF(WSOSK.LT.0.0)WSOSK=WSOSK*RHOK
C
        DO 390 IQ=1,3
          RQ(IQ)=RQ(IQ)+RHOK*AGRAV*(DNX(IQ)*AKXZK+DNZ(IQ)*AKZK)-
     >           WSOSK*N(IQ)
          DO 340 JQ=1,3
            QA(IQ,JQ)=QA(IQ,JQ) + FHP*N(IQ)*N(JQ)
            QB(IQ,JQ)=QB(IQ,JQ) + DNX(IQ)*(AKXK*DNX(JQ)+AKXZK*DNZ(JQ)) +
     1                DNZ(IQ)*(AKXZK*DNX(JQ)+AKZK*DNZ(JQ))
  340     CONTINUE
  390   CONTINUE
C
  490 CONTINUE
C
      IF(ILUMP.EQ.0) RETURN
C
C ------- FOR THE CASES WHEN THE MASS MATRIX IS TO BE LUMPED
C
      DO 690 I=1,3
      SUM=0.0
      DO 640 J=1,3
      SUM=SUM+QA(I,J)
  640 QA(I,J)=0.0
      QA(I,I)=SUM
  690 CONTINUE
C
      RETURN
      END
c
c
c
      SUBROUTINE FQ4(QA,QB,RQ,DTHG,AKXG,AKZG,AKXZG,RHOQ,XQ,ZQ,WSOSM,
     1 AGRAV)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO EVALUATE ELEMENT MASS AND STIFF MATRICES AND ELEMENT LOAD
C ------- VECTOR FOR A QUADRILATERAL ELEMENT.
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- INPUT: THG,DTHG,AKXG,AKZG,AKXZG,  XQ,ZQ,  WSOSM,  AGRAV.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 N(4)
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
      DIMENSION QA(4,4),QB(4,4),RQ(4),DTHG(4),AKXG(4),AKZG(4),
     1 AKXZG(4),RHOQ(4),XQ(4),ZQ(4)
C
      DIMENSION S(4),T(4),DNX(4),DNZ(4)
      DIMENSION PJAB(2,2),DNSS(4),DNTT(4)
C
      DATA P/0.577350269189626/, S/-1.0D+00,1.0D+00,1.0D+00,-1.0D+00/,
     1 T/-1.0D+00,-1.0D+00,1.0D+00,1.0D+00/
C
C ------- INITIATE MATRICES QA, QB, AND RQ
C
      DO 110 IQ=1,4
      RQ(IQ)=0.0
      DO 110 JQ=1,4
      QA(IQ,JQ)=0.0
      QB(IQ,JQ)=0.0
  110 CONTINUE
C
      DO 490 KG=1,4
C
C ------- DETERMINE LOACAL COORDINATE (SS,TT) OF GAUSSIAN POINT KG
C
      IF(IQUAR.EQ.11 .OR. IQUAR.EQ.21)THEN
        SS=S(KG)
        TT=T(KG)
      ELSE
        SS=P*S(KG)
        TT=P*T(KG)
      ENDIF
C
C ------- CALCULATE VALUES OF BASIS FUNCTIONS N(IQ) AND THEIR
C ------- DERIVATIVES DNX(IQ) AND DNZ(IQ) W.R.T. X AND Z, RESPECTIVELY
C ------- AT THE GAUSSIAN POINT KG.
C
         CALL BASE(N,DNSS,DNTT,SS,TT)
C
      DO 210 I=1,2
      DO 210 J=1,2
  210 PJAB(I,J)=0.0
C
      DO 220 I=1,4
      PJAB(1,1)=PJAB(1,1)+ZQ(I)*DNTT(I)
      PJAB(1,2)=PJAB(1,2)-ZQ(I)*DNSS(I)
      PJAB(2,1)=PJAB(2,1)-XQ(I)*DNTT(I)
      PJAB(2,2)=PJAB(2,2)+XQ(I)*DNSS(I)
  220 CONTINUE
C
      DJAC=PJAB(2,2)*PJAB(1,1)-PJAB(1,2)*PJAB(2,1)
      DJACI=1.0D0/DJAC
C
      DO 230 I=1,2
      DO 230 J=1,2
      PJAB(I,J)=PJAB(I,J)*DJACI
  230 CONTINUE
C
      DO 260 I=1,4
      DNX(I)=DNSS(I)*PJAB(1,1)+DNTT(I)*PJAB(1,2)
      DNZ(I)=DNSS(I)*PJAB(2,1)+DNTT(I)*PJAB(2,2)
  260 CONTINUE
C
        AKXQP=AKXG(KG)
        AKXZQP=AKXZG(KG)
        AKZQP=AKZG(KG)
        RHOK=RHOQ(KG)
      DTHQP=DTHG(KG)*RHOK
C
C ------- ACCUMULATE THE SUMS TO OBTAIN THE MATRIX INTEGRALS QQ(IQ,JQ)
C ------- AND RQ(IQ)
C
      FHP=DTHQP*DJAC
      AKXQP=AKXQP*DJAC
      AKXZQP=AKXZQP*DJAC
      AKZQP=AKZQP*DJAC
      WSOSK=WSOSM*DJAC
      IF(WSOSK.LT.0.0)WSOSK=WSOSK*RHOK
C
      DO 390 IQ=1,4
      RQ(IQ)=RQ(IQ)+RHOK*AGRAV*(DNX(IQ)*AKXZQP+DNZ(IQ)*AKZQP)-
     >       WSOSK*N(IQ)
      DO 390 JQ=1,4
      QA(IQ,JQ)=QA(IQ,JQ) + FHP*N(IQ)*N(JQ)
      QB(IQ,JQ)=QB(IQ,JQ) + DNX(IQ)*(AKXQP*DNX(JQ)+AKXZQP*DNZ(JQ)) +
     1 DNZ(IQ)*(AKXZQP*DNX(JQ)+AKZQP*DNZ(JQ))
  390 CONTINUE
C
  490 CONTINUE
C
      IF(ILUMP.EQ.0) RETURN
C
C ***** FOR THE CASES WHEN THE MASS MATRIX IS TO BE LUMPED
C
      DO 690 I=1,4
        SUM=0.0
        DO 640 J=1,4
          SUM=SUM+QA(I,J)
          QA(I,J)=0.0
  640   CONTINUE
        QA(I,I)=SUM
  690 CONTINUE
C
      RETURN
      END
c
c
c
      SUBROUTINE FQ4D(QB,QRX,QRZ,XQ,ZQ,AKXG,AKZG,AKXZG,HQ,RHOQ,AGRAV)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO COMPUTE THE VELOCITY STIFF MATRIX AND LOAD VECTORS FOR A
C ------- QUADRILATERAL ELEMENT.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 N(4)
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
      DIMENSION QB(4,4),QRX(4),QRZ(4),XQ(4),ZQ(4),HQ(4),RHOQ(4),
     1 AKXG(4),AKZG(4),AKXZG(4)
C
      DIMENSION S(4),T(4),DNX(4),DNZ(4)
      DIMENSION PJAB(2,2),DNSS(4),DNTT(4)
C
      DATA P/0.577350269189626d0/
      data s/-1.0D+00, 1.0D+00, 1.0D+00,-1.0D+00/,
     1  T/-1.0D+00,-1.0D+00, 1.0D+00, 1.0D+00/
C
C ------- INITIATE MATRICES QB(IQ,JQ) AND QRX(IQ) & QRZ(IQ)
C
      DO 100 IQ=1,4
      QRX(IQ)=0.0
      QRZ(IQ)=0.0
      DO 100 JQ=1,4
  100 QB(IQ,JQ)=0.0
C
C ------- SUMMATION OF THE INTEGRAND OVER THE GAUSSIAN POINTS
C
      DO 490 KG=1,4
C
C ------- DETERMINE LOACAL COORDINATE (SS,TT) OF GAUSSIAN POINT KG
C
        IF(IQUAR.EQ.11 .OR. IQUAR.EQ.21)THEN
          SS=S(KG)
          TT=T(KG)
        ELSE
          SS=P*S(KG)
          TT=P*T(KG)
        ENDIF
C
C ------- CALCULATE VALUES OF BASIS FUNCTIONS N(IQ) AND THEIR
C ------- DERIVATIVES DNX(IQ) AND DNZ(IQ) W.R.T. X AND Z, RESPECTIVELY
C ------- AT THE GAUSSIAN POINT KG.
C
         CALL BASE(N,DNSS,DNTT,SS,TT)
C
      DO 210 I=1,2
      DO 210 J=1,2
  210 PJAB(I,J)=0.0
C
      DO 220 I=1,4
      PJAB(1,1)=PJAB(1,1)+ZQ(I)*DNTT(I)
      PJAB(1,2)=PJAB(1,2)-ZQ(I)*DNSS(I)
      PJAB(2,1)=PJAB(2,1)-XQ(I)*DNTT(I)
      PJAB(2,2)=PJAB(2,2)+XQ(I)*DNSS(I)
  220 CONTINUE
C
      DJAC=PJAB(2,2)*PJAB(1,1)-PJAB(1,2)*PJAB(2,1)
      DJACI=1.0D0/DJAC
C
      DO 230 I=1,2
      DO 230 J=1,2
      PJAB(I,J)=PJAB(I,J)*DJACI
  230 CONTINUE
C
      DO 260 I=1,4
      DNX(I)=DNSS(I)*PJAB(1,1)+DNTT(I)*PJAB(1,2)
      DNZ(I)=DNSS(I)*PJAB(2,1)+DNTT(I)*PJAB(2,2)
  260 CONTINUE
C
        AKXK=AKXG(KG)
        AKZK=AKZG(KG)
        AKXZK=AKXZG(KG)
        RHOMK=RHOQ(KG)
C
C ------- ACCUMULATE THE SUMS TO OBTAIN THE MATRIX INTEGRALS QB(IQ,JQ)
C ------- AND QRX(IQ) & QRZ(IQ)
C
      DO 390 IQ=1,4
        QRX(IQ)=QRX(IQ)-N(IQ)*AKXZK*DJAC*AGRAV
        QRZ(IQ)=QRZ(IQ)-N(IQ)*AKZK*DJAC*AGRAV
      DO 390 JQ=1,4
      QB(IQ,JQ)=QB(IQ,JQ)+N(IQ)*N(JQ)*DJAC
      QRX(IQ)=QRX(IQ)-N(IQ)*HQ(JQ)*(AKXK*DNX(JQ)+AKXZK*DNZ(JQ))*DJAC
     >       /RHOMK
      QRZ(IQ)=QRZ(IQ)-N(IQ)*HQ(JQ)*(AKXZK*DNX(JQ)+AKZK*DNZ(JQ))*DJAC
     >       /RHOMK
  390 CONTINUE
C
  490 CONTINUE
C
      RETURN
      END
c
c
c
      SUBROUTINE SPROP
     I          (IE,H,C,PROP,RHOMU,DINTS,SPP, IRHO,IQUAR,
     O           TH,DTH,AKHC,RHOM)
C
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 N(4),L1(3),L2(3),L3(3),LL1(3),LL2(3),LL3(3),L1KG,L2KG,L3KG
C
      COMMON /SGEOM/ MAXEL,MAXNP,MAXBES,MAXBNP,MAXBW,MXJBD,MAXHBP,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
      COMMON /HRCNT/ TOLAH,TOLBH,Wf,OMEH,OMIH,CNSTKR
      COMMON /CHEM/ MXNCC,NCC
C
      DIMENSION IE(MAXEL,7),H(MAXNP),TH(MAXEL,4),DTH(MAXEL,4),
     >          AKHC(4,MAXEL,3)
C
      DIMENSION PROP(MAXMAT,MXMPPM),SPP(MXSPPM,MAXMAT,4)
      DIMENSION RHOMU(MXNCC),DINTS(MXNCC),RHOM(4,MAXEL),C(MAXNP,MXNCC)
C
c      DIMENSION HQ(4), S(4),T(4), HKG(4),CQ(4,7),CKG(7,4),AMU(4)
      DIMENSION HQ(4), S(4),T(4), HKG(4),CQ(4,7),CKG(7,4)
C
      DATA P / 0.577350269189626D0 /
      DATA S / -1.0D+00, 1.0D+00, 1.0D+00,-1.0D+00 /, T / -1.0D+00,
     >         -1.0D+00, 1.0D+00, 1.0D+00 /
C
      DATA L1/0.666666666666667D0, 0.166666666666667D0,
     1        0.166666666666667D0/
      DATA L2/0.166666666666667D0, 0.666666666666667D0,
     1        0.166666666666667D0/
      DATA L3/0.166666666666667D0, 0.166666666666667D0,
     1        0.666666666666667D0/
      DATA LL1/1.0D0,0.0D0,0.0D0/
      DATA LL2/0.0D0,1.0D0,0.0D0/
      DATA LL3/0.0D0,0.0D0,1.0D0/
C
c      AGRAV=DBLE(KGRAV)
C
C -------- TH, DTH/DH, AKX, AND AKZ ARE OBTAINED BY TABLE
C
      DO 900 M=1,NEL
      NQ=4
      IEM4=IE(M,4)
      IF(IEM4.EQ.0) NQ=3
C
      DO 110 IQ=1,NQ
      NP=IE(M,IQ)
      DO K=1,NCC
        CQ(IQ,K)=C(NP,K)
      ENDDO
  110 HQ(IQ)=H(NP)
C
      IF(NQ.EQ.4) THEN
C
C ------- EVALUATE PRESSURE AT FOUR GAUSSIAN POINTS FOR QUADRILATERAL
C ------- ELEMENT.
C
      DO 150 KG=1,NQ
        IF(IQUAR.EQ.11 .OR. IQUAR.EQ.21)THEN
          SS=S(KG)
          TT=T(KG)
        ELSE
          SS=P*S(KG)
          TT=P*T(KG)
        ENDIF
      SM=1.0D0-SS
      SP=1.0D0+SS
      TM=1.0D0-TT
      TP=1.0D0+TT
C
      N(1)=0.25D0*SM*TM
      N(2)=0.25D0*SP*TM
      N(3)=0.25D0*SP*TP
      N(4)=0.25D0*SM*TP
C
      HKG(KG)=0.0
      DO K=1,NCC
        CKG(K,KG)=0.0D0
      ENDDO
      DO 120 IQ=1,NQ
      HKG(KG)=HKG(KG)+HQ(IQ)*N(IQ)
      DO K=1,NCC
        CKG(K,KG)=CKG(K,KG)+CQ(IQ,K)*N(IQ)
      ENDDO
  120 CONTINUE
  150 CONTINUE
      ENDIF
C
C ------- EVALUATE PRESSURE AT NODES FOR TRIANGULAR ELEMENT.
C
      IF(NQ.EQ.3)THEN
      DO 180 KG=1,3
        IF(IQUAR.EQ.11 .OR. IQUAR.EQ.21)THEN
          L1KG=LL1(KG)
          L2KG=LL2(KG)
          L3KG=LL3(KG)
        ELSE
          L1KG=L1(KG)
          L2KG=L2(KG)
          L3KG=L3(KG)
        ENDIF
        N(1)=L1KG
        N(2)=L2KG
        N(3)=L3KG
        HKG(KG)=0.0
        DO K=1,NCC
          CKG(K,KG)=0.0D0
        ENDDO
        DO 170 IQ=1,NQ
          HKG(KG)=HKG(KG) + N(IQ)*HQ(IQ)
          DO K=1,NCC
            CKG(K,KG)=CKG(K,KG)+N(IQ)*CQ(IQ,K)
          ENDDO
  170   CONTINUE
  180 CONTINUE
      END IF
C
      MTYP=IE(M,5)
      SATKX=PROP(MTYP,1)
      SATKZ=PROP(MTYP,2)
      SATKXZ=PROP(MTYP,3)
      RHOW=PROP(MTYP,4)
C
         DO 800 KG=1,NQ
            HNP=HKG(KG)
            HNP=-HNP
C
            CALL SPFUNC
     I       (HNP,SPP,MTYP,KSP,SATKX,SATKZ,SATKXZ,RHOW,0,
     I        RHOMU,DINTS,CNSTKR,IRHO,CKG(1,KG),
     O        TH(M,KG),DTH(M,KG),AKHC(KG,M,1),AKHC(KG,M,2),AKHC(KG,M,3),
     O        RHOM(KG,M))
  800    CONTINUE
  900 CONTINUE
C
      RETURN
      END
C
c
c
      SUBROUTINE SPFUNC
     I   (HNP,SPP,MTYP,KSP,SATKX,SATKZ,SATKXZ,RHOW,ISP,RHOMU,DINTS,
     O    CNSTKR,IRHO,CKG,  TH,DTH,AKHCX,AKHCZ,AKHCXZ,RHOM)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
      COMMON /CHEM/ MXNCC,NCC
C
      DIMENSION SPP(MXSPPM,MAXMAT,4),RHOMU(MXNCC),DINTS(MXNCC),CKG(7)
C
C ----- COMPUTE RHO/RHOW
C
      RHOM=1.0D0
      AMU=1.0D0
      IF(IRHO.EQ.1) CALL RHOFUN(RHOM,AMU,RHOW,DINTS,CKG,RHOMU)
C
      IF(KSP.EQ.1) THEN
        HNP=-HNP
C
C ------- TH, DTH/DH, AKX, AKZ, AND AKXZ ARE OBTAINED BY TABLE
C
        IF(HNP.GT.SPP(1,MTYP,4)) GO TO 200
C
C ------- FOR CASE  WHEN PRESSURE IS LESS THAN MINIMUM TABULET VALUE.
C
        JL=1
        JU=2
        A=0.0
        GO TO 400
C
  200   IF(HNP.LT.SPP(NSPPM,MTYP,4)) GO TO 250
C
C ------- FOR CASE  WHEN PRESSURE IS  GT THAN MAXIMUM TABULET VALUE.
C
        JL=NSPPM
        JU=1
        A=0.0
        GO TO 400
C
C ------- FOR CASE  WHEN PRESSURE LIES BETWEEN TABULET VALUES.
C
  250   DO 300 J=2,NSPPM
          JU=J
          IF(SPP(J,MTYP,4).GT.HNP) GO TO 350
  300   CONTINUE
  350   JL=JU-1
        A=(HNP-SPP(JL,MTYP,4))/(SPP(JU,MTYP,4)-SPP(JL,MTYP,4))
C
C ------- THREE CASES MERGE HERE.
C
  400   TH=SPP(JL,MTYP,1)+A*(SPP(JU,MTYP,1)-SPP(JL,MTYP,1))
        IF(ISP.EQ.1)GOTO 900
        DTH=SPP(JL,MTYP,3)+A*(SPP(JU,MTYP,3)-SPP(JL,MTYP,3))
        USKFCT=SPP(JL,MTYP,2)+A*(SPP(JU,MTYP,2)-SPP(JL,MTYP,2))
C
        IF(USKFCT.LT.CNSTKR)USKFCT=CNSTKR
C
        AKHCX=SATKX*USKFCT*RHOM/AMU
        AKHCZ=SATKZ*USKFCT*RHOM/AMU
        AKHCXZ=SATKXZ*USKFCT*RHOM/AMU
C
      ELSE
C
C
C ------- TH, DTH/DH, AKX, AKZ, AND AKXZ ARE OBTAINED ANALYTICALLY.
C ------- THE READER MUST SUPPLY THE FUNCTIONAL FORM OF FKX, FKZ, AND
C ------- FTH BELOW
C
C ------- THE FOLLOWING IS JUST AN EXAMPLE.
C ------- WCR= THPROP(MTYP,1)=0.065, 0.050 FOR TWO SAMPLE MATERUALS
C ------- WCS=THPROP(MTYP,2)=0.364, 0.341 FOR TWO SAMPLE MATERIALS
C ------- RN=THPROP(MTYP,3)=1.092217, 1.546937 FOR TWO SAMPLE MATERIALS
C ------- ALPH=THPROP(MTYP,4)=0.109, 0.002166 FOR TWO SAMPLE MATERIALS
C
C %%%% EXAMPLE 1
C
c        WCR=SPP(1,MTYP,1)
c        WCS=SPP(2,MTYP,1)
c        HAA=SPP(3,MTYP,1)
c        HAB=SPP(4,MTYP,1)
C
C %%%% EXAMPLE 2
C
c       wcr=spp(1,mtyp,1)
c       wcs=spp(2,mtyp,1)
c       haa=spp(3,mtyp,1)
c       thaa=spp(4,mtyp,1)
c       thbb=spp(5,mtyp,1)
c       power=spp(1,mtyp,2)
C
C %%%% EPA HYPOTHETICAL CASE
C
      wcr=spp(1,mtyp,1)
      wcs=spp(2,mtyp,1)
      alpha=spp(3,mtyp,1)
      alamda=spp(4,mtyp,1)
      alphai=1.0d0/alpha
CC
CC------- SATURATED CONDITION
CC
C
C %%%% EXAMPLE 1
C
c        IF(HNP.GT.0.0) GO TO 700
C
C %%%% EXAMPLE 2
C
c        IF(HNP.GT.0.0) GO TO 700
C
C %%%% EPA HYPOTHETICAL CASE
C
        if(hnp.gt.alphai) GOTO 700
CC
CC
        TH=WCS
        IF(ISP.EQ.1)GOTO 900
        DTH=0.0D0
        AKHCX=SATKX*RHOM/AMU
        AKHCZ=SATKZ*RHOM/AMU
        AKHCXZ=SATKXZ*RHOM/AMU
        GOTO 900
CC
CC ------- UNSATURATED CASE
CC
  700   CONTINUE
C
C %%%%% EXAMPLE 1
C
c        THMKG=WCs-(WCS-WCR)*(-hnp-haa)/(hab-haa)
c        TH=THMKG
c        IF(ISP.EQ.1)GOTO 900
c        rk=((thmkg-wcr)/(wcs-wcr))
c        DTH=-(wcs-wcr)/(hab-haa)
C
C %%%%% EXAMPLE 2
C
c       thmkg=wcr+(wcs-wcr)*thaa/(thaa+(dabs(-hnp-haa))**thbb)
c       th=thmkg
c       IF(ISP.EQ.1)GOTO 900
c       dnom=thaa+(dabs(-hnp-haa))**thbb
c       dth=(wcs-wcr)*thaa*(dabs(-hnp-thaa))**(thbb-1.0d0)
c    >              /dnom**2
c       RK=((THMKG-WCR)/(WCS-WCR))**POWER
C
C %%%%% EPA HYPOTHETICAL CASE
C
         th=wcr+(wcs-wcr)*(alpha*hnp)**(-alamda)
         IF(ISP.EQ.1)GOTO 900
         rk=1.0d0/(alpha*hnp)**(alamda*3+2)
         dth=alpha*alamda*(wcs-wcr)*(alpha*hnp)**(-alamda-1.0d0)
CC
CC
        IF(RK.LT.CNSTKR)RK=CNSTKR
        AKHCX=SATKX*rk*RHOM/AMU
        AKHCZ=SATKZ*rk*RHOM/AMU
        AKHCXZ=SATKXZ*rk*RHOM/AMU
      ENDIF
C
  900 RETURN
      END
c
c
c
      SUBROUTINE FSTORE(COORD,IE,DLCSB,ISB,NPBB,INDRS,H,HT,TH,VELOC,
     1  TITLE, NPROB,ITM)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO STORE GEOMETRY, VARIABLE BOUNDARY NODE INDEX, PRESSURE
C ------- HEAD, TOTAL HEAD, MOISTURE CONTENT, AND DARCY'S VELOCITY
C ------- AS NEEDED.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
C
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
C
      COMMON /TIMEI/ MAXNTI,MXNDTC,NTI,NDTCHG
      COMMON /TIMER/ DELT,CHNG,DELMAX,TMAX,DELT0,TIME
C
C
      DIMENSION COORD(MAXNP,2),IE(MAXEL,9)
      DIMENSION DLCSB(3,MAXBES),ISB(5,MAXBES),NPBB(MAXBNP)
      DIMENSION INDRS(MXRNP,3)
      DIMENSION H(MAXNP),HT(MAXNP),TH(MAXEL,4),VELOC(MAXNP,2)
C
      CHARACTER*72 TITLE
C
      DATA NPPROB/-1/
C
      IF(NPPROB.EQ.(-1)) REWIND 11
      IF(NPPROB.EQ.NPROB) GO TO 110
      WRITE(11) TITLE,NPROB,NNP,NEL,NBNP,NBES,NTI,NRNP
      WRITE(11) ((COORD(N,I),I=1,2),N=1,NNP),((IE(M,I),M=1,NEL),I=1,5),
     1 ((DLCSB(I,M),I=1,3),M=1,NBES),(ISB(5,M),M=1,NBES),
     2 ((ISB(I,M),I=1,4),M=1,NBES),(NPBB(N),N=1,NBNP)
      NPPROB=NPROB
C
  110 WRITE(11)ITM,TIME,(H(N),N=1,NNP),(HT(N),N=1,NNP),((TH(M,I),I=1,4),
     >     M=1,NEL),((VELOC(N,I),I=1,2),N=1,NNP),((INDRS(N,I),I=1,3),
     >     N=1,NRNP)
C
      RETURN
      END
c
c
c
      SUBROUTINE VELT
     I               (COORD,IE, H,AKHC,RHOM,
     O                VELOC,HT,
     M                CMATRX)
C
C********1*********2*********3*********4*********5*********6*********7**
C
C ------- TO COMPUTE DARCY'S VELOCITY COMPONENTS.
C
C********1*********2*********3*********4*********5*********6*********7**
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
      COMMON /HICNT/ NCYL,NITERH,NPITERH,KSTRH,KSSH,KSP,KGRAV
C
      DIMENSION VELOC(MAXNP,2),HT(MAXNP),CMATRX(MXADNP,MAXBW)
      DIMENSION COORD(MAXNP,2),IE(MAXEL,9)
      DIMENSION H(MAXNP),AKHC(4,MAXEL,3),RHOM(4,MAXEL)
C
      DIMENSION QB(4,4),QRX(4),QRZ(4),XQ(4),ZQ(4),HQ(4),
     1 AKXG(4),AKZG(4),AKXZG(4),RHOQ(4)
C
c      IHALFB=(IBAND-1)/2
      AGRAV=DBLE(KGRAV)
C
C ------- INITIATE THE DARCY VELOCITY VX(NP) AND VZ(NP)
C
      DO NP=1,NNP
        DO I=1,2
          VELOC(NP,I)=0.0
        ENDDO
      ENDDO
C
C ------- CALCULATE THE TOTAL HEAD HT(NP)
C
      DO NP=1,NNP
        HT(NP)=H(NP) +AGRAV*COORD(NP,2)
      ENDDO
C
C ------- INITIATE MATRIX CMATRX(NP,IB)
C
      IF(IPNTS.EQ.1 .OR. IVML.EQ.1) THEN
        DO NP=1,NNP
          CMATRX(NP,1)=0.0D0
        ENDDO
      ELSE
        DO NP=1,NNP
          DO IB=1,IHBP
            CMATRX(NP,IB)=0.0D0
          ENDDO
        ENDDO
      ENDIF
C
C ------- COMPUTE ELEMENT MATRICES QB(IQ,JQ) AND QRX(IQ) & QRZ(IQ)
C
      DO 290 M=1,NEL
c      MTYP=IE(M,5)
      NQ=4
      IEM4=IE(M,4)
      IF(IEM4.EQ.0) NQ=3
C
      DO 210 IQ=1,NQ
        NP=IE(M,IQ)
        XQ(IQ)=COORD(NP,1)
        ZQ(IQ)=COORD(NP,2)
        AKXG(IQ)=AKHC(IQ,M,1)
        AKZG(IQ)=AKHC(IQ,M,2)
        AKXZG(IQ)=AKHC(IQ,M,3)
        HQ(IQ)=H(NP)
        RHOQ(IQ)=RHOM(IQ,M)
  210 CONTINUE
C
C     GAMAMU=PROP(MTYP,4)/PROP(MTYP,5)
C
      IF(NQ.EQ.3)CALL FQ3D(QB,QRX,QRZ,XQ,ZQ,AKXG,AKZG,AKXZG,HQ,RHOQ,
     >                     AGRAV)
      IF(NQ.EQ.4)CALL FQ4D(QB,QRX,QRZ,XQ,ZQ,AKXG,AKZG,AKXZG,HQ,RHOQ,
     >                     AGRAV)
C
C ------- ASSEMBLE QB(IQ,JQ) INTO THE GLOBAL MATRIX CMATRX(NP,IB) AND
C ------- FORM THE LOAD VECTOR VX(NP) OR VZ(NP)
C
      DO 280 IQ=1,NQ
      NI=IE(M,IQ)
      DO 240 JQ=1,NQ
      NJ=IE(M,JQ)
C
      IF(IPNTS.EQ.1 .OR. IVML.EQ.1) GO TO 230
C
      IF(NJ.LT.NI) GO TO 240
      IB=NJ-NI+1
      CMATRX(NI,IB)=CMATRX(NI,IB)+QB(IQ,JQ)
      GO TO 240
C
  230 CMATRX(NI,1)=CMATRX(NI,1)+QB(IQ,JQ)
  240 CONTINUE
C
      VELOC(NI,1)=VELOC(NI,1)+QRX(IQ)
      VELOC(NI,2)=VELOC(NI,2)+QRZ(IQ)
  280 CONTINUE
C
  290 CONTINUE
C
C ------- SOLVE THE MATRIX EQUATION CX=B
C
      IF(IPNTS.EQ.1 .OR. IVML.EQ.1) GO TO 360
C
      CALL BANSOL(1,CMATRX,VELOC(1,1),NNP,IHBP,MXADNP,MAXBW,MAXNP)
      CALL BANSOL(2,CMATRX,VELOC(1,1),NNP,IHBP,MXADNP,MAXBW,MAXNP)
      CALL BANSOL(2,CMATRX,VELOC(1,2),NNP,IHBP,MXADNP,MAXBW,MAXNP)
C
      RETURN
C
  360 DO 370 NP=1,NNP
      VELOC(NP,1)=VELOC(NP,1)/CMATRX(NP,1)
  370 VELOC(NP,2)=VELOC(NP,2)/CMATRX(NP,1)
C
      RETURN
      END
c
c
c
      SUBROUTINE FSFLOW
     I         (X,IE,NLRL,LRL,DCOSLB,ISB,NPBB, H,HP,V,TH,DTH, DELT,
     I          KFLOW,RHOM,PROP,DINTS,RHOMU,ISTYPT,SOST,IWTYPT,WSST,C,
     I          SOS,ISTYP,NPVB,NPDB,NPCB,NPNB,  WSS,IWTYP, IRHO,
     M          BFLX)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /SGEOM/ MAXEL,MAXNP,MXADNP,MAXBES,MAXBNP,MAXBW,MXJBD,MXKBD
      COMMON /CGEOM/ NEL,NNP,NBES,NBNP,IBAND,IHBP,ishape
      COMMON /SCMTL/ MAXMAT,MXSPPM,MXMPPM,NMAT,NSPPM,NMPPM
C
      COMMON /HELS/ MXSELH,MXSPRH,MXSDPH,NSELH,NSPRH,NSDPH,KSAIH
      COMMON /HNPS/ MXWNPH,MXWPRH,MXWDPH,NWNPH,NWPRH,NWDPH,KWAIH
      COMMON /TELS/ MXSEL,MXSPR,MXSDP,NSEL,NSPR,NSDP,KSAI
      COMMON /TNPS/ MXWNP,MXWPR,MXWDP,NWNP,NWPR,NWDP,KWAI
C
      COMMON /HCBC/ MXCNPH,MXCESH,MXCPRH,MXCDPH,NCNPH,NCESH,NCPRH,
     >              NCDPH,KCAIH
      COMMON /HNBC/ MXNNPH,MXNESH,MXNPRH,MXNDPH,NNNPH,NNESH,NNPRH,
     >              NNDPH,KNAIH
      COMMON /HRBC/ MXRES,MXRNP,MXRPR,MXRDP,NRES,NRNP,NRPR,NRDP,KRAIH
      COMMON /HDBC/ MXDNPH,MXDPRH,MXDDPH,NDNPH,NDPRH,NDDPH,KDAIH
C
      COMMON /CHEM/ MXNCC,NCC
C
      COMMON /FFLOW/ FRATE(10),FLOW(10),TFLOW(10)
C
      DIMENSION X(MAXNP,2),IE(MAXEL,9),C(MAXNP,MXNCC)
      DIMENSION NLRL(MAXNP),LRL(MXKBD,MAXNP),PROP(MAXMAT,MXMPPM)
C
      DIMENSION H(MAXNP),HP(MAXNP),V(MAXNP,2)
      DIMENSION TH(MAXEL,4),DTH(MAXEL,4),RHOM(4,MAXEL)
C
      DIMENSION DCOSLB(3,MAXBES),ISB(5,MAXBES),NPBB(MAXBNP)
      DIMENSION BFLX(MAXBNP,2)
C
      DIMENSION SOS(MXSPRH),ISTYP(MXSELH,2)
      DIMENSION WSS(MXWPRH),IWTYP(MXWNPH,2)
      DIMENSION ISTYPT(MXSEL,MXNCC),SOST(MXSPR,2)
      DIMENSION IWTYPT(MXWNP,MXNCC),WSST(MXWPR,2)
      DIMENSION DINTS(MXNCC),RHOMU(MXNCC)
C
      DIMENSION NPVB(MXRNP),NPDB(MXDNPH),NPCB(MXCNPH),NPNB(MXNNPH)
C
      DIMENSION XQ(4),ZQ(4),DHQ(4),THG(4),RHOQ(4),CKG(7)
C
C     DATA TWOPI/6.283185307D0/
      DATA QSOS/0.0D0/
C
      DO 110 NP=1,NBNP
      BFLX(NP,1)=BFLX(NP,2)
      BFLX(NP,2)=0.0
  110 CONTINUE
C
C ******* CALCULATE VOLUMETRIC FLOW RATE PER UNIT Y-LENGTH FOR ALL
C ******* BOUNDARY NODES
C
      DO 170 MP=1,NBES
      M=ISB(5,MP)
      NI=ISB(1,MP)
      NJ=ISB(2,MP)
C     RR=((X(NI,1)+X(NJ,1))/2.0D0)*TWOPI
C     IF(CYLIND.EQ.0.0) RR=1.0D0
      RR=1.0D0
      DO 120 I=1,NBNP
      IJ=NPBB(I)
      IF(IJ.NE.NI) GO TO 120
      NII=I
      GO TO 130
  120 CONTINUE
  130 DO 140 J=1,NBNP
      IJ=NPBB(J)
      IF(IJ.NE.NJ) GO TO 140
      NJJ=J
      GO TO 150
  140 CONTINUE
  150 CONTINUE
C
C ------- COMPUTE THE CONTRIBUTION OF SIDE (NI,NJ) TO THE TOTAL FLUX
C ------- THROUGH POINTS NI AND NJ, RESPECTIVELY.
C
      FNI=(V(NI,1)*DCOSLB(1,MP)+V(NI,2)*DCOSLB(2,MP))*DCOSLB(3,MP)*RR
      FNJ=(V(NJ,1)*DCOSLB(1,MP)+V(NJ,2)*DCOSLB(2,MP))*DCOSLB(3,MP)*RR
C
C ------- DISTRIBUTE THE ABOVE FLUXES TO TOW END POINTS OF THE SIDE
C
      BFLX(NII,2)=BFLX(NII,2)+FNI/3.0D0+FNJ/6.0D0
      BFLX(NJJ,2)=BFLX(NJJ,2)+FNJ/3.0D0+FNI/6.0D0
C
  170 CONTINUE
C
      IF (KFLOW.GT.0) GO TO 200
      DO 180 NP=1,NBNP
      BFLX(NP,1)=BFLX(NP,2)
  180 CONTINUE
C
      DO 190 I=1,9
  190 TFLOW(I)=0.0
C
C ******* DETERMINE TOTAL FLOWS AND TOTAL FLOW RATES THROUGH VARIOUS
C ******* TYPES OF BOUNDARIES, STARTING WITH THE NET FLOWS THROUGH THE
C ******* ENTIRE BOUNDARY.
C
  200 SUM=0.
      SUMP=0.
      DO 210 NP=1,NBNP
      SUM=SUM+BFLX(NP,2)
      SUMP=SUMP+BFLX(NP,1)
  210 CONTINUE
C
      FRATE(7)=SUM
      FLOW(7)=0.5D0*(SUM+SUMP)*DELT
C
C ******* THE DIRICHLET BOUNDARY
C
      FRATE(1)=0.
      FLOW(1)=0.
      IF(NDNPH.LE.0) GO TO 400
      SUM=0.
      SUMP=0.
      DO 330 NPP=1,NDNPH
      NP=NPDB(NPP)
         DO 310 I=1,NBNP
      IJ=NPBB(I)
      IF(IJ.NE.NP) GO TO 310
      NII=I
      GO TO 320
  310 CONTINUE
  320 CONTINUE
      SUM=SUM+BFLX(NII,2)
      SUMP=SUMP+BFLX(NII,1)
  330 CONTINUE
      FRATE(1)=SUM
      FLOW(1)=0.5D0*(SUM+SUMP)*DELT
C
C ******* THE CAUCHY BOUNDARY
C
  400 FRATE(2)=0.0
      FLOW(2)=0.0
      IF(NCNPH.LE.0) GO TO 500
      SUM=0.0
      SUMP=0.0
      DO 430 NPP=1,NCNPH
         NP=NPCB(NPP)
         DO 410 I=1,NBNP
            IJ=NPBB(I)
            IF(IJ.NE.NP) GO TO 410
            NII=I
            GO TO 420
  410    CONTINUE
  420    CONTINUE
         SUM=SUM+BFLX(NII,2)
         SUMP=SUMP+BFLX(NII,1)
  430 CONTINUE
      FRATE(2)=SUM
      FLOW(2)=0.5D0*(SUM+SUMP)*DELT
C
C ******* THE NEUMANN BOUNDARY
C
  500 FRATE(3)=0.
      FLOW(3)=0.
      IF(NNNPH.LE.0) GO TO 600
      SUM=0.
      SUMP=0.
      DO 530 NPP=1,NNNPH
         NP=NPNB(NPP)
      DO 510 I=1,NBNP
      IJ=NPBB(I)
      IF(IJ.NE.NP) GO TO 510
      NII=I
      GO TO 520
  510 CONTINUE
  520 CONTINUE
      SUM=SUM+BFLX(NII,2)
      SUMP=SUMP+BFLX(NII,1)
  530 CONTINUE
      FRATE(3)=SUM
      FLOW(3)=0.5D0*(SUM+SUMP)*DELT
C
C ******* THE RAINFALL-SEEPAGE BOUNDARY
C
  600 FRATE(4)=0.
      FLOW(4)=0.
      FRATE(5)=0.
      FLOW(5)=0.
      IF(NRNP.LE.0) GO TO 700
      SUMS=0.
      SUMSP=0.
      SUMR=0.
      SUMRP=0.
      DO 640 NPP=1,NRNP
         NP=NPVB(NPP)
         DO 610 I=1,NBNP
            IJ=NPBB(I)
            IF(IJ.NE.NP) GO TO 610
            NII=I
            GO TO 620
  610       CONTINUE
  620    CONTINUE
         BFLXA=BFLX(NII,2)
         IF (BFLXA.LT.0.D0) GO TO 630
         SUMS=SUMS+BFLX(NII,2)
         SUMSP=SUMSP+BFLX(NII,1)
         GO TO 640
  630    SUMR=SUMR+BFLX(NII,2)
         SUMRP=SUMRP+BFLX(NII,1)
  640    CONTINUE
      FRATE(4)=SUMS
      FLOW(4)=0.5D0*(SUMS+SUMSP)*DELT
      FRATE(5)=SUMR
      FLOW(5)=0.5D0*(SUMR+SUMRP)*DELT
C
C ******* THE UNSPECIFIED BOUNDARY, I. E. BOUNDARY WITH ZERO TOTAL FLUX
C
  700 SUM=0.
      SUMP=0.
      DO 710 I=1,5
      SUM=SUM+FRATE(I)
  710 SUMP=SUMP+FLOW(I)
      FRATE(6)=FRATE(7)-SUM
      FLOW(6)=FLOW(7)-SUMP
C
C ******* CALCULATE THE INCREASE IN THE WATER CONTENT AND THE SOURCE
C
      QSOSP=QSOS
      QSOS=0.0
      QTH=0.
      DO 830 M=1,NEL
      NQ=4
      IEM4=IE(M,4)
      IF(IEM4.EQ.0) NQ=3
      MTYP=IE(M,5)
C        ALP=PROP(MTYP,1)
C        BETAP=PROP(MTYP,2)
C        POR=PROP(3,MTYP)
C
      SOURCE=0.0
      IF(NSELH.LE.0.0) GO TO 805
      DO 802 I=1,NSELH
      MP=ISTYP(I,2)
      IF(MP.EQ.M) GO TO 804
  802 CONTINUE
      GO TO 805
  804 ITYP=ISTYP(I,1)
      SOURCE=SOS(ITYP)
      IF(IRHO.EQ.1 .AND. SOURCE.GT.0.0D0)THEN
        MTYP=IE(M,5)
        RHOW=PROP(MTYP,4)
        DO K=1,NCC
          ITYP=ISTYPT(I,K)
          CKG(K)=SOST(ITYP,2)
        ENDDO
        CALL RHOFUN(RHOSTR,AMU,RHOW,DINTS,CKG,RHOMU)
        SOURCE=SOURCE*RHOSTR
      ENDIF
  805 CONTINUE
C
      DO 810 IQ=1,NQ
        NP=IE(M,IQ)
        XQ(IQ)=X(NP,1)
        ZQ(IQ)=X(NP,2)
        RHOQ(IQ)=RHOM(IQ,M)
        DHQ(IQ)=H(NP)-HP(NP)
        IF(KFLOW.LE.0) DHQ(IQ)=1.0D0
  810 CONTINUE
C
      DO 820 KG=1,NQ
      THG(KG)=TH(M,KG)
C     IF(KFLOW.GT.0) THG(KG)=DTH(M,KG)+ALP*THG(KG)/POR+BETAP*THG(KG)
      IF(KFLOW.GT.0) THG(KG)=DTH(M,KG)
  820 CONTINUE
C
      IF(NQ.EQ.3) CALL Q3TH(QTHM,DHQ,XQ,ZQ,THG,QSOSM,SOURCE,RHOQ)
      IF(NQ.EQ.4) CALL Q4TH(QTHM,DHQ,XQ,ZQ,THG,QSOSM,SOURCE,RHOQ)
C
         QSOS=QSOS-QSOSM
         QTH=QTH+QTHM
  830 CONTINUE
C
      IF(NWNPH.EQ.0) GO TO 850
      DO 840 I=1,NWNPH
        NI=IWTYP(I,2)
        ITYP=IWTYP(I,1)
        IF(IRHO.EQ.1)THEN
          RHO=0.0D0
          AREAT=0.0D0
          DO J=1,NLRL(NI)
            MP=LRL(J,NI)
            MTYP=IE(MP,5)
            CALL ELENOD(IE(MP,4),NODE)
            CALL AREA(MAXNP,MAXEL,X(1,1),X(1,2),IE,MP,NODE,
     >                AREAE)
            RHO=RHO+PROP(MTYP,4)*AREAE
            AREAT=AREAT+AREAE
          ENDDO
          RHOW=RHO/AREAT
          WSSK=WSS(ITYP)
C
          IF(WSSK.LT.0.0D0)THEN
            DO K=1,NCC
              CKG(K)=C(NI,K)
            ENDDO
          ELSEIF(WSSK.GT.0.0D0)THEN
            DO K=1,NCC
              ITYP=IWTYPT(I,K)
              CKG(K)=WSST(ITYP,2)
            ENDDO
          ENDIF
          CALL RHOFUN(RHO,AMU,RHOW,DINTS,CKG,RHOMU)
          WSSK=WSSK*RHO
        ENDIF
      QSOS=QSOS-WSSK
  840 CONTINUE
  850 CONTINUE
C
      IF(KFLOW.GT.0) GO TO 880
      QSOSP=QSOS
CC
  880 FRATE(8)=QSOS
      FLOW(8)=0.5D0*(QSOS+QSOSP)*DELT
      FLOW(9)=QTH
      FRATE(9)=FLOW(9)/DELT
      IF(KFLOW.LE.0) FRATE(9)=-(FRATE(7)+FRATE(8))
C
      DO 910 I=1,9
  910    TFLOW(I)=TFLOW(I)+FLOW(I)
C
      RETURN
      END
c
c
c
      SUBROUTINE Q3TH(QTHM,DHQ,XQ,ZQ,THG,QSOSM,SOURCE,RHOQ)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 L1(3),L2(3),L3(3),LL1(3),LL2(3),LL3(3),N(3)
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
C
      DIMENSION XQ(4),ZQ(4),DHQ(4),THG(4),RHOQ(4)
      DIMENSION A(3), WG(3)
C
      DATA L1/0.666666666666667D0, 0.166666666666667D0,
     1        0.166666666666667D0/
      DATA L2/0.166666666666667D0, 0.666666666666667D0,
     1        0.166666666666667D0/
      DATA L3/0.166666666666667D0, 0.166666666666667D0,
     1        0.666666666666667D0/
      DATA LL1/1.0D0,0.0D0,0.0D0/
      DATA LL2/0.0D0,1.0D0,0.0D0/
      DATA LL3/0.0D0,0.0D0,1.0D0/
      DATA WG/0.333333333333333D0, 0.333333333333333D0,
     1        0.333333333333333D0/
C
      QSOSM=0.0
      QTHM=0.
C
      X1=XQ(1)
      X2=XQ(2)
      X3=XQ(3)
      Z1=ZQ(1)
      Z2=ZQ(2)
      Z3=ZQ(3)
      A(1)=X2*Z3 - X3*Z2
      A(2)=X3*Z1 - X1*Z3
      A(3)=X1*Z2 - X2*Z1
C
      AREA2=DABS(A(1)+A(2)+A(3))
      AREA=AREA2/2.0D0
C
      DO 490 KG=1,3
C
C ------- DETERMINE NATURAL COORDINATE (L1,L2,L3) OF GAUSSIAN POINT KG
C
        IF(IQUAR.EQ.11 .OR. IQUAR.EQ.21)THEN
          L1KG=LL1(KG)
          L2KG=LL2(KG)
          L3KG=LL3(KG)
        ELSE
          L1KG=L1(KG)
          L2KG=L2(KG)
          L3KG=L3(KG)
        ENDIF
C
C ------- CALCULATE VALUES OF BASIS FUNCTIONS N(IQ)
C
        N(1)=L1KG
        N(2)=L2KG
        N(3)=L3KG
C
C ------- INTERPOLATE TO OBTAIN WATER CONTENT AT THE GAUSSIAN POINT KG
C
        DHQP=0.0
        R=0.0
        DO 390 IQ=1,3
          DHQP=DHQP+DHQ(IQ)*N(IQ)
          R=R+XQ(IQ)*N(IQ)
  390   CONTINUE
C
          THQP=DHQP*THG(KG)
          RR=1.0D0*AREA*WG(KG)
C         IF(CYLIND.NE.0.0) RR=R*AREA*WG(KG)
C
C ------- ACCUMULATE THE SUM TO EVALUATE THE INTEGRAL
C
           QSOSM=QSOSM+SOURCE*RR*RHOQ(KG)
           QTHM=QTHM+THQP*RR
  490 CONTINUE
C
      RETURN
      END
c
c
c
      SUBROUTINE Q4TH(QTHM,DHQ,XQ,ZQ,THG,QSOSM,SOURCE,RHOQ)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 N(4)
C
      COMMON /COPTN/ IMID,IWET,ILUMP,IOPTIM,IPNTS,IVML,IQUAR,IDISP
      COMMON /COORD/ CSFE,SNFE,CYLIND
C
      DIMENSION THG(4),S(4),T(4),XQ(4),ZQ(4),DHQ(4),RHOQ(4)
      DIMENSION PJAB(2,2),DNSS(4),DNTT(4)
C
      DATA P / 0.577350269189626 /, S / -1.0D+00, 1.0D+00, 1.0D+00,-
     > 1.0D+00 /, T / -1.0D+00,-1.0D+00, 1.0D+00, 1.0D+00 /
C
      QSOSM=0.0
      QTHM=0.
      DO 490 KG=1,4
C
C ------- DETERMINE LOACAL COORDINATE (SS,TT) OF GAUSSIAN POINT KG
C
      IF(IQUAR.EQ.11 .OR. IQUAR.EQ.21)THEN
        SS=S(KG)
        TT=T(KG)
      ELSE
        SS=P*S(KG)
        TT=P*T(KG)
      ENDIF
C
C ------- CALCULATE VALUES OF BASIS FUNCTIONS N(IQ)
C
         CALL BASE(N,DNSS,DNTT,SS,TT)
C
      DO 210 I=1,2
      DO 210 J=1,2
  210 PJAB(I,J)=0.0
C
      DO 220 I=1,4
      PJAB(1,1)=PJAB(1,1)+ZQ(I)*DNTT(I)
      PJAB(1,2)=PJAB(1,2)-ZQ(I)*DNSS(I)
      PJAB(2,1)=PJAB(2,1)-XQ(I)*DNTT(I)
      PJAB(2,2)=PJAB(2,2)+XQ(I)*DNSS(I)
  220 CONTINUE
C
      DJAC=PJAB(2,2)*PJAB(1,1)-PJAB(1,2)*PJAB(2,1)
C
C ------- INTERPOLATE TO OBTAIN WATER CONTENT AT THE GAUSSIAN POINT KG
C
      DHQP=0.0
      R=0.0
      DO 390 IQ=1,4
      DHQP=DHQP+DHQ(IQ)*N(IQ)
      R=R+XQ(IQ)*N(IQ)
  390 CONTINUE
C
      THQP=DHQP*THG(KG)
      RR=1.0D0
C     IF(CYLIND.NE.0.0) RR=R
C
C ------- ACCUMULATE THE SUM TO EVALUATE THE INTEGRAL
C
         QSOSM=QSOSM+SOURCE*DJAC*RR*RHOQ(KG)
         QTHM=QTHM+THQP*DJAC*RR
  490 CONTINUE
C
      RETURN
      END
c
c
c
      SUBROUTINE F2CNVB(RQ,DL,CIN1,CIN2,RHOQ,VN1,VN2,IBC)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 N(2)
C
      DIMENSION RQ(2), S(2),RHOQ(2)
C
      DATA P/1.0D0/
      DATA S/-1.0D0,1.0D0/
C
C ------- INITIALIZE NODAL COMPONENTS OF LINE INTEGRAL.
C
      DO 110 JQ=1,2
      RQ(JQ)=0.0
  110 CONTINUE
C
C ------- EVALUATE INTEGRATION BY SUMMING OVER ALL INTEGRATION POINTS.
C
      DO 590 KG=1,2
      SS=P*S(KG)
      N(1)=0.5D0*(1.0D0-SS)
      N(2)=0.5D0*(1.0D0+SS)
C
C ------- INTERPOLATE WITH BASE FUNCTIONS TO OBTAIN INTEGRAND AT
C ------- INTEGRATION POINTS.
C
      CINK=CIN1*N(1)+CIN2*N(2)
      RHOK=RHOQ(1)*N(1)+RHOQ(2)*N(2)
      IF(IBC.EQ.2)THEN
        IF(KG.EQ.1)VNK=VN1
        IF(KG.EQ.2)VNK=VN2
      ENDIF
C
      DO 560 IQ=1,2
        IF(IBC.EQ.1 .OR. IBC.EQ.3)RQ(IQ)=RQ(IQ)-N(IQ)*CINK*RHOK
        IF(IBC.EQ.2)RQ(IQ)=RQ(IQ)+N(IQ)*(RHOK*VNK-CINK)
  560 CONTINUE
C
  590 CONTINUE
C
      DO 690 IQ=1,2
        RQ(IQ)=RQ(IQ)*0.5D0*DL
  690 CONTINUE
C
      RETURN
      END
c
c
c
      SUBROUTINE RHOFUN(RHOM,AMU,RHOW,DINTS,CKG,RHOMU)
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMMON /CHEM/ MXNCC,NCC
C
      DIMENSION DINTS(MXNCC),RHOMU(MXNCC),CKG(7)
C
      RHOM=1.0D0
      AMU=1.0D0
        DO K=1,NCC
          RHOM=RHOM+(1.0D0/RHOW-1.0D0/DINTS(K))*CKG(K)
          AMU=AMU+RHOMU(K)*CKG(K)
C         RHOM=1.0D0+RHOMU(1)*CKG(K)
        ENDDO
      RETURN
      END
